﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Threading;
using System.Diagnostics;   // use View > Output to see debug messages
using System.Globalization;
using System.Net;
using System.Net.NetworkInformation;  // so we don't have country issues with '.' and ',' in KK.csv files

using System.Timers;  //w3sz
using System.Net.Sockets; //w3sz
using System.Threading.Tasks;
using System.Media; //w3sz
using System.Collections; //w3sz
using System.Linq; //w3sz
using System.Resources; //w3sz

namespace Moving_Forms_Test
{
    public partial class _222MHz : Form
    {
        Form1 form1;
        SetupForm222 Setup222;
        public KKMethod KKDevice = KKMethod.Ethernet;

        private object _waterfallLockObj = new object();

        /// <summary>
        /// below are variables for Setupform222
        /// </summary>
        public static double AGCMaximumGainDB;
        public static string w3szendpoint1 = Properties.Settings.Default.w3szendpoint222;
        private static int port1 = 8003;
        public int SampleRate = 192000;
        public static int FFTSize; //added by w3sz  pre-existing in Receiver.cs
        public int BlockSize; //added by w3sz  pre-existing in Receiver.cs
        public SetupForm222 Setup_form222 = null;  // get reference to the Setup form.
        public static int xWidth = Globals.xWidth;
        public int BSHeight;

        // the following contain the last used VFO frequency on each band
        public long xvtr_frequency;
        public long xvtr_frequencyB;
        public string split_tx_freq;
        // the following hold the last state of the preamp on each band
        public bool Preamp_222;

        /// <summary>
        /// end of variables-for-Setupform section
        /// </summary>
   
        public byte[] frequency = new byte[4];             // hold Penny and Mercury frequency when in simplex mode and Penny when in Duplex   
        public byte[] duplex_frequency = new byte[4];      // holds Mercury frequency when in Duplex mode
        int step_size; // the frequency step using the mouse scroll wheel
        public OperMode CurrentMode;
        public string ModeText;
        long previous_frequency_value;

        public int rate=15;            // sets bandscope update rate in F.P.S.
        public int Rate
        {
            get { return rate; }
            set
            {
                rate = value;
            }
        }     
               
        public static int GridMax = 20;     // sets maximum value of Bandscope display
        public static int GridMin = -160;  // sets minimum value of Bandscope display
        public static int GridStep = 20;   // sets distance between grid lines on bandscope 

        public int WaterfallStep = 0; // sets the distance in pixels the line moves per Waterfall scan

        int delta;                  // difference between the current and previous mouse position on the bandscope
        string KeypadFrequency = null;     // holds the frequency entered using the keypad
        int keycount = 0;           // holds number of key presses of the  keypad
        bool ShowCross = false;     // when set show cross at current mouse location
        int MousePositionX;         // as it says
        int MousePositionY;         // you guessed it!
        long FilterLeft;             // left hand location of filter on bandscope
        long FilterRight;            // Hmm... now let me see...
        bool FrequencyDrag = true;  // true when we can drag tune with the mouse
        bool BandwidthShift = true; // true when can drag shift the filter
        bool HighFilter = false;    // true when we can drag high filter frequency
        bool LowFilter = false;     // true when we can drag low filter frequency       
        public static bool WaterfallAGC = false;  // true when Waterfall AGC is selected on the Setup form
        float max_signal = 200.0f;      // maximum value of nPS in the array, used by  bandscope squelch
        int min_signal = 0;
        int xpos_max;
        int xpos_min;
        int filter_max_signal = -200;  // maximum signal through the current filter, used by the filter, squelch
        int pixels_per_GridStep;     // how many pixels a Grid Step represents in the narrow bandscope 
        double pixelsperdB;
        public bool KK_on = false;           // true when KK is running

        int squelch_y_value = 0;                // Y location of the squelch threshold line 
        Rectangle squelch = new Rectangle();    // the little rectangle at the LH end of the squelch line.
        public static float TxFilterHigh = 3500f;  // Transmitter high filter setting
        public static float TxFilterLow = 300f;    // Transmitter low filter setting
        public float DriveGain = 0.50f;     // Determines the drive level to Penelope
        public static int Gain10m = 50;
        public static int Gain6m = 50;
        public int BandGain = 50;           // Determines gain for Penelope, set by what ever band selected
        public static bool Duplex = Properties.Settings.Default.Duplex222;         // Selects full duplex operation
        public static bool OnlyTxOnPTT = true;     // part of full duplex, only Tx when PTT set
        public bool MOX_set = false;               // set when PTT active
        public bool TUN_set = false;               // set when Tune active
        public static int TuneLevel = 50;          // sets Tune power as a % of Drive setting
        bool previous_OnlyTxOnPTT;          // hold previous Only Tx on PTT start so we can restore 

        public bool PTTEnable = false;

        Point MouseOld = new Point(); // keep location of mouse for drag tuning 

        NumberFormatInfo nfi = NumberFormatInfo.InvariantInfo;  // so we are region independent in terms of ',' and '.' for floats

        // these are used by the SMeter 
        int SMeterValue = 0;          // this gets passed to the SMeter code 
        Font meterFont = new Font(FontFamily.GenericSansSerif, 7);  // use smaller font for the meter
        int SMeterReceived = 0;

        Pen YellowPen = Pens.Yellow;
        Pen RedPen = Pens.Red;
        Pen WhitePen = Pens.White;
        Pen ChartreusePen = Pens.Chartreuse;
        Pen dotPen = (Pen)Pens.DarkOrange.Clone();
        Point[] bandDraw;
        public double FilterFrequencyLow;
        public double FilterFrequencyHigh;
        public bool PTT;
        public float VolumeLeft;
        public float VolumeRight;
        public string Drive;
        public int Drive222;
        
        static int lineCount = 10000;  //w3sz

        public int oldXwidth=xWidth;

        public string app_data_path = "";
        public string KKCSVName = "";

        public string[] arr;  //w3sz

        static int[] xx = new int[lineCount];  //w3sz
        static float[] yy = new float[lineCount];  //w3sz
        static int ji = 0; //w3sz
        static bool displayready = false; //w3sz
        public long LO;
        public long LOoffset;
        public long LO_222;
        public long LOoffset_222;

        public static string color_scheme; // = "enhanced";
        private static int LinCor = 2;
        private static int LinLogCor = -14;
        bool MoxServerStatus = false;
           
        public _222MHz(Form1 parent)
        {
            InitializeComponent();
            form1 = parent;
            Setup222 = new SetupForm222(this);

            Sidetone.Checked = Globals.sidetonechecked;

            DisplayFrequencyB(Properties.Settings.Default.split_tx_freq222);
            splitBox.Checked = false;
            splitBox_CheckedChanged(this, EventArgs.Empty);

            this.FormClosing += new FormClosingEventHandler(Form_Closing);
            this.pictureBox1.MouseClick += new MouseEventHandler(_222MHz_pictureBox1_MouseClick);
            this.pictureBox1.MouseDoubleClick += new MouseEventHandler(_222MHz_pictureBox1_MouseDoubleClick);
            this.MOX.MouseDown += new MouseEventHandler(MOX_MouseDown);
            this.TUN.MouseDown += new MouseEventHandler(TUN_MouseDown);
            this.Size = Globals.formsmallsize;
            pictureBox1.Size = Globals.boxsmallsize;
            pictureBox1.Location = Globals.box1smallloc;
            this.Location = Globals.form222smallloc;
            Zoom100.Checked = true;
            Zoom100_CheckedChanged(this, EventArgs.Empty);
            this.Invalidate();
            
            pictureBox1.SizeMode = PictureBoxSizeMode.Zoom;
            BandwidthTrackBar.BringToFront();
            labelFilterWidth.BringToFront();

            System.Timers.Timer aTimer = new System.Timers.Timer();  //w3sz  this is needed when not running with actual IQ data
            aTimer.Elapsed += new ElapsedEventHandler(OnTimedEvent);  //w3sz
            aTimer.Interval = 40;  //w3sz
            aTimer.Enabled = true;  //w3sz
            byte[] udpcw = {1};
            
            startThreads();

            Debug.Indent();      

            // make the pen for the squelch line on the spectrum display have 'dot' properties
            dotPen.DashStyle = System.Drawing.Drawing2D.DashStyle.Dot;

            // draw 
            pictureBox3.Paint += new PaintEventHandler(pictureBox3_Paint); // SMeter event handler
            pictureBox3.Height = 40;
            pictureBox3.Width = 140;

            VolumeTrackBar.Minimum = 0;
            VolumeTrackBar.Maximum = 100;
          
            this.Invalidate();
        }

        public void startThreads()
        {
            if (Properties.Settings.Default.Checked222)
            {
                // start getting spectrum data from client socket and place in circular buffer section
                ThreadPool.QueueUserWorkItem(delegate //w3sz
                {
                    UdpClient udpServer = new UdpClient(6003);
                    IPEndPoint localpt = new IPEndPoint(IPAddress.Parse(w3szendpoint1), 6003); //w3sz spectrum data receiver

                    int testflag = 0;
                    Globals.once222 = true;

                    while (Globals.stopper == false) //w3sz
                    {
                        try
                        {
                            byte[] buffer = udpServer.Receive(ref localpt); //w3sz
                            for (int i = 0; i < buffer.Length; i += 4)
                            {
                                yy[ji] = -500 + BitConverter.ToSingle(buffer, i);
                                ji = ji + 1;
                            }

                            if (ji >= 1024)
                            {
                                displayready = true;
                                ji = 0;
                                testflag = 1;
                            }
                        }
                        catch
                        {
                            Console.WriteLine("Exception occurred in initial thread");
                        }
                    }
                });

                // start getting power and SMeter data from server
                ThreadPool.QueueUserWorkItem(delegate //w3sz
                {
                    IPEndPoint localpt3 = new IPEndPoint(IPAddress.Parse(w3szendpoint1), 7003); //w3sz power and SMeter data receiver
                    /// 8003 is used for commands
                    /// 9003 is used by the dll for setting FFTsize

                    UdpClient udpServer3 = new UdpClient(7003); //w3sz

                    while (Globals.stopper == false) //w3sz
                    {
                        try
                        {
                            byte[] buffer3 = udpServer3.Receive(ref localpt3); //w3sz 
                            string sbuffer3 = Encoding.UTF8.GetString(buffer3, 0, buffer3.Length);
                            //put data handling routines here

                            if (sbuffer3.StartsWith("FwdPwr"))
                            {
                                sbuffer3 = sbuffer3.Remove(0, 6);
                                //       Console.WriteLine("FwdPwr Received from UI: " + sbuffer3.ToString());
                                Invoke((MethodInvoker)delegate
                                {
                                    label7.Text = "FwdPwr " + sbuffer3;
                                });
                            }
                            else if (sbuffer3.StartsWith("RevPwr"))
                            {
                                sbuffer3 = sbuffer3.Remove(0, 6);
                                //        Console.WriteLine("RevPwr Received from UI: " + sbuffer3.ToString());
                                Invoke((MethodInvoker)delegate
                                {
                                    label8.Text = "RevPwr" + sbuffer3;
                                });
                            }
                            else if (sbuffer3.StartsWith("SMeter"))
                            {
                                sbuffer3 = sbuffer3.Remove(0, 6);
                                //        Console.WriteLine("SMeterValue Received from UI: " + sbuffer3.ToString());
                                Invoke((MethodInvoker)delegate
                                {
                                    SMeterReceived = Convert.ToInt32(sbuffer3);
                                });
                            }
                            else if (sbuffer3.StartsWith("FFTSize"))
                            {
                                sbuffer3 = sbuffer3.Remove(0, 7);
                                //        Console.WriteLine("FFTSize Received from Server: " + sbuffer3.ToString());
                                Invoke((MethodInvoker)delegate
                                {
                                    FFTSize = Convert.ToInt32(sbuffer3);

                                    if (IsFormOpen(typeof(SetupForm222)))
                                    {
                                        Setup_form222.FFTSize.Text = sbuffer3;
                                    }

                                });
                            }
                            else if (sbuffer3.StartsWith("MoxSet"))
                            {
                                sbuffer3 = sbuffer3.Remove(0, 6);
                                //        Console.WriteLine("MoxSet Received from Server: " + sbuffer3.ToString());
                                Invoke((MethodInvoker)delegate
                                {
                                    MoxServerStatus = Convert.ToBoolean(sbuffer3);
                                    if (MoxServerStatus == false)
                                    {
                                        MOX_Ind.BackColor = SystemColors.Control;
                                    }
                                    else
                                    {
                                        MOX_Ind.BackColor = Color.Green;
                                    }
                                });
                            }
                            else if (sbuffer3.StartsWith("FiltWi"))
                            {
                                sbuffer3 = sbuffer3.Remove(0, 6);
                                //        Console.WriteLine("MoxSet Received from Server: " + sbuffer3.ToString());
                                Invoke((MethodInvoker)delegate
                                {
                                    BandwidthTrackBar.Value = int.Parse(sbuffer3);
                                    BandwidthTrackBar_ValueChanged(this, EventArgs.Empty);
                                    AdjustFilterByMode();
                                });
                            }

                            pictureBox3.Invalidate();
                        }
                        catch
                        {
                        }
                    }
                });
            }


        }

        public static bool IsFormOpen(Type formType)
        {
            foreach (Form form in Application.OpenForms)
                if (form.GetType().Name == formType.Name)
                {
                    return true;
                }
            return false;
        }

        private delegate void ObjectDelegate(object obj);

        void OnTimedEvent(object source, ElapsedEventArgs e)  //w3sz  needed because client has IQ signals are available
        {
   
            if (displayready == true)
            {
                        ComputeDisplay(); // w3sz 
                        UpdateGraphs();  //w3sz
                        displayready = false;
            }
        }

        
        int waterfall_low_threshold = -200;
        public int WaterfallLowThreshold
        {
            get { return waterfall_low_threshold; }
            set { waterfall_low_threshold = value; }
        }

        int waterfall_high_threshold = 0;
        public int WaterfallHighThreshold
        {
            get { return waterfall_high_threshold; }
            set { waterfall_high_threshold = value; }
        }

        public int FFTLowLimit;  //w3sz
        public int FFTHiLimit;  //w3sz
        public int FFTSpan;
        public double FFTRadioPerCent;
        public double FFTPerCent;
        public double FFTPixDispRatio;
        public double FreqSpan = 192000;   //starts with sampling rate 192000 and no zoom
 //       public int FFTLowLimitIntegerRatio;
        public int FFTPixDispRatioInteger;  

        // computed during one ComputeDisplay block, and used in the next.
        // May be set to WaterfallLowThreshold if not doing waterfall AGC.
        // This value, and not waterfall_low_threshold, is used in the calculations in ComputeDisplay
        float waterfallPreviousMinValue = 100;
        float waterfallPreviousMaxValue = -300;
       //++++++++++++++++++++++++++++++++++++++++++++++++  start ComputeDisplay()


        private void ComputeDisplay()
        {
            int WFHeight;          
            float waterfall_minimum = 100;  // reset waterfall_minimum value in nPS array 
            float waterfall_maximum = -300;
            // set to just above black for now for testing but make a user setting and save in KK.csv
            int waterfall_low_color_R = 0; int waterfall_low_color_G = 0; int waterfall_low_color_B = 0;
            int waterfall_high_color_R = 255; int waterfall_high_color_G = 255; int waterfall_high_color_B = 1;
            int waterfall_mid_color_R = 128; int waterfall_mid_color_G = 128; int waterfall_mid_color_B = 128;
            int R = 0, G = 0, B = 0;
            float range;
            float off_set;
            float overall_percent; // value from 0.0 to 1.0 where 1.0 is high and 0.0 is low.
            float local_percent;

            if ((Globals.main222 == false) & (Globals.aux222 == false))
            {
                BSHeight = Globals.boxsmallsize.Height/2;
                WFHeight = Globals.boxsmallsize.Height/2;
                xWidth = Globals.boxsmallsize.Width; // max number of pixels across the screen
            }
            else
            {
                BSHeight = Globals.boxlargesize.Height/2;
                WFHeight = Globals.boxlargesize.Height/2;
                xWidth = Globals.boxlargesize.Width; // max number of samples across the screen
            }
            
            max_signal = 0;  // reset maximum value of nPS in the array
            min_signal = 0; //w3sz

            if ((bandDraw == null) || (oldXwidth != xWidth))
            {
                // only create these arrays (and populate them!) if not created, or if xWidth changes...
                bandDraw = new Point[1024];

                // populate the arrays.  Only do this when the size (xWidth) changes, to minimize memory allocation
                for (int i = 0; i < 1024; ++i)
                {
                    bandDraw[i] = new Point();
                }

                oldXwidth = xWidth;
            }
            // advance to the next waterfall line and count it
        
                NextWaterfallLine();

                if (!WaterfallAGC)  // if selected then set the low threshold automatically
                    waterfallPreviousMinValue = WaterfallLowThreshold;

                byte[] rawData = new byte[1024 * 4];  //was xWidth  //w3sz
                int xposadj;  //adjusting xpos for display size; original data is 1024 x 1024.  New data is xWidth x BSHeight  //w3sz
  
            for (int xpos = 1; xpos < 1024; xpos++)
            {
                xposadj = Convert.ToInt32(xpos * xWidth / 1024f);  //w3sz

                if (yy[xpos] != -60000)  // if added 12/20/2016
                {
                    bandDraw[xpos].X = xposadj;  //w3sz
                    bandDraw[xpos].Y = dBToPixelContinuous(-85 + yy[xpos]);  //w3sz  
                }
                else
                {
                    if (xpos > 0)
                    {
                        bandDraw[xpos].X = xposadj;   //w3sz
                        bandDraw[xpos].Y = bandDraw[xpos - 1].Y;  //w3sz  
                    }
                }

                // This code is based on the waterfall in PowerSDR 

                // from the above explanation we know the dBm value of each sample is  nPS - logGain

                float waterfall_data = -85 + yy[xpos] ;  //w3sz

//Switch for various waterfall schemes
                    switch (Globals.color_scheme)
                    {
                        case ("original"):
                            {
                                // draw new data
                                //int R, G, B;		// variables to save Red, Green and Blue component values

                                    if (waterfall_data <= waterfallPreviousMinValue)		// if less than low threshold, just use low color
                                    {
                                        R = waterfall_low_color_R;
                                        G = waterfall_low_color_G;
                                        B = waterfall_low_color_B;
                                    }
                                    else if (waterfall_data >= waterfall_high_threshold)// if more than high threshold, just use high color
                                    {
                                        R = waterfall_high_color_R;
                                        G = waterfall_high_color_G;
                                        B = waterfall_high_color_B;
                                    }
                                    else // use a color between high and low
                                    {
                                        float percent = (waterfall_data - waterfallPreviousMinValue) / (waterfall_high_threshold - waterfallPreviousMinValue);
                                        if (percent <= 0.5)	// use a gradient between low and mid colors
                                        {
                                            percent *= 2;

                                            R = Convert.ToInt32((1 - percent) * waterfall_low_color_R + percent * waterfall_mid_color_R);
                                            G = Convert.ToInt32((1 - percent) * waterfall_low_color_G + percent * waterfall_mid_color_G);
                                            B = Convert.ToInt32((1 - percent) * waterfall_low_color_B + percent * waterfall_mid_color_B);
                                        }
                                        else				// use a gradient between mid and high colors
                                        {
                                            percent = (float)(percent - 0.5) * 2;

                                            R = Convert.ToInt32((1 - percent) * waterfall_mid_color_R + percent * waterfall_high_color_R);
                                            G = Convert.ToInt32((1 - percent) * waterfall_mid_color_G + percent * waterfall_high_color_G);
                                            B = Convert.ToInt32((1 - percent) * waterfall_mid_color_B + percent * waterfall_high_color_B);
                                        }
                                    
                                }

                                    rawData[xposadj * 4] = (byte)B;  //w3sz
                                    rawData[1 + xposadj * 4] = (byte)G;  //w3sz
                                    rawData[2 + xposadj * 4] = (byte)R;  //w3sz
                                    rawData[3 + xposadj * 4] = 255;  //w3sz
                            }
                             break;

                        case ("enhanced"):
                            {
                                // draw new data
                                    if (waterfall_data <= waterfallPreviousMinValue)
                                    {
                                        R = waterfall_low_color_R;
                                        G = waterfall_low_color_G;
                                        B = waterfall_low_color_B;
                                    }
                                    else if (waterfall_data >= waterfall_high_threshold)
                                    {
                                        R = 192;
                                        G = 124;
                                        B = 255;
                                    }
                                    else // value is between low and high
                                    {
                                        range = waterfall_high_threshold - waterfallPreviousMinValue;
                                        off_set = waterfall_data - waterfallPreviousMinValue;
                                        overall_percent = off_set / range; // value from 0.0 to 1.0 where 1.0 is high and 0.0 is low.

                                        if (overall_percent < (float)2 / 9) // background to blue
                                        {
                                            local_percent = overall_percent / ((float)2 / 9);
                                            R = Convert.ToInt32((1.0 - local_percent) * waterfall_low_color_R);
                                            G = Convert.ToInt32((1.0 - local_percent) * waterfall_low_color_G);
                                            B = Convert.ToInt32(waterfall_low_color_B + local_percent * (255 - waterfall_low_color_B));
                                        }
                                        else if (overall_percent < (float)3 / 9) // blue to blue-green
                                        {
                                            local_percent = (overall_percent - (float)2 / 9) / ((float)1 / 9);
                                            R = 0;
                                            G = Convert.ToInt32(local_percent * 255);
                                            B = 255;
                                        }
                                        else if (overall_percent < (float)4 / 9) // blue-green to green
                                        {
                                            local_percent = (overall_percent - (float)3 / 9) / ((float)1 / 9);
                                            R = 0;
                                            G = 255;
                                            B = Convert.ToInt32((1.0 - local_percent) * 255);
                                        }
                                        else if (overall_percent < (float)5 / 9) // green to red-green
                                        {
                                            local_percent = (overall_percent - (float)4 / 9) / ((float)1 / 9);
                                            R = Convert.ToInt32(local_percent * 255);
                                            G = 255;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)7 / 9) // red-green to red
                                        {
                                            local_percent = (overall_percent - (float)5 / 9) / ((float)2 / 9);
                                            R = 255;
                                            G = Convert.ToInt32((1.0 - local_percent) * 255);
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)8 / 9) // red to red-blue
                                        {
                                            local_percent = (overall_percent - (float)7 / 9) / ((float)1 / 9);
                                            R = 255;
                                            G = 0;
                                            B = Convert.ToInt32(local_percent * 255);
                                        }
                                        else // red-blue to purple end
                                        {
                                            local_percent = (overall_percent - (float)8 / 9) / ((float)1 / 9);
                                            R = Convert.ToInt32((0.75 + 0.25 * (1.0 - local_percent)) * 255);
                                            G = Convert.ToInt32(local_percent * 255 * 0.5);
                                            B = 255;
                                        }
                                    }

                                    rawData[xposadj * 4] = (byte)B;  //w3sz
                                    rawData[1 + xposadj * 4] = (byte)G;  //w3sz
                                    rawData[2 + xposadj * 4] = (byte)R;  //w3sz
                                    rawData[3 + xposadj * 4] = 255;  //w3sz

                            }
                            break;

                        case ("SPECTRAN"):
                            {
                                // draw new data
                                    if (waterfall_data <= waterfallPreviousMinValue)
                                    {
                                        R = 0;
                                        G = 0;
                                        B = 0;
                                    }
                                    else if (waterfall_data >= WaterfallHighThreshold) // white
                                    {
                                        R = 240;
                                        G = 240;
                                        B = 240;
                                    }
                                    else // value is between low and high
                                    {
                                        range = WaterfallHighThreshold - waterfallPreviousMinValue;
                                        off_set = waterfall_data - waterfallPreviousMinValue;
                                        local_percent = ((100.0f * off_set) / range);

                                        if (local_percent < 5.0f)
                                        {
                                            R = G = 0;
                                            B = Convert.ToInt32(local_percent * 5);
                                        }
                                        else if (local_percent < 11.0f)
                                        {
                                            R = G = 0;
                                            B = Convert.ToInt32(local_percent * 5);
                                        }
                                        else if (local_percent < 22.0f)
                                        {
                                            R = G = 0;
                                            B = Convert.ToInt32(local_percent * 5);
                                        }
                                        else if (local_percent < 44.0f)
                                        {
                                            R = G = 0;
                                            B = Convert.ToInt32(local_percent * 5);
                                        }
                                        else if (local_percent < 51.0f)
                                        {
                                            R = G = 0;
                                            B = Convert.ToInt32(local_percent * 5);
                                        }
                                        else if (local_percent < 66.0f)
                                        {
                                            R = G = Convert.ToInt32((local_percent - 50) * 2);
                                            B = 255;
                                        }
                                        else if (local_percent < 77.0f)
                                        {
                                            R = G = Convert.ToInt32((local_percent - 50) * 3);
                                            B = 255;
                                        }
                                        else if (local_percent < 88.0f)
                                        {
                                            R = G = Convert.ToInt32((local_percent - 50) * 4);
                                            B = 255;
                                        }
                                        else if (local_percent < 99.0f)
                                        {
                                            R = G = Convert.ToInt32((local_percent - 50) * 5);
                                            B = 255;
                                        }
                                    }

                                    rawData[xposadj * 4] = (byte)B;  //w3sz
                                    rawData[1 + xposadj * 4] = (byte)G;  //w3sz
                                    rawData[2 + xposadj * 4] = (byte)R;  //w3sz
                                    rawData[3 + xposadj * 4] = 255;  //w3sz

                            }
                            break;

                        case ("BLACKWHITE"):
                            {
                                // draw new data
                                    if (waterfall_data <= waterfallPreviousMinValue)
                                    {
                                        R = 0;
                                        G = 0;
                                        B = 0;
                                    }
                                    else if (waterfall_data >= WaterfallHighThreshold) // white
                                    {
                                        R = 255;
                                        G = 255;
                                        B = 255;
                                    }
                                    else // value is between low and high
                                    {
                                        range = WaterfallHighThreshold - waterfallPreviousMinValue;
                                        off_set = waterfall_data - waterfallPreviousMinValue;
                                        local_percent = ((100.0f * off_set) / range);
                                        R = Convert.ToInt32((local_percent / 100) * 255);
                                        G = R;
                                        B = R;
                                    }

                                    rawData[xposadj * 4] = (byte)B;  //w3sz
                                    rawData[1 + xposadj * 4] = (byte)G;  //w3sz
                                    rawData[2 + xposadj * 4] = (byte)R;  //w3sz
                                    rawData[3 + xposadj * 4] = 255;  //w3sz

                            }
                            break;

                        case ("LinLog"):
                            {
                                    if (waterfall_data <= waterfallPreviousMinValue)
                                    {
                                        R = 0;
                                        G = 0;
                                        B = 0;
                                    }
                                    else if (waterfall_data >= waterfall_high_threshold)
                                    {
                                        R = 252;
                                        G = 252;
                                        B = 252;
                                    }
                                    else // value is between low and high
                                    {
                                        range = waterfall_high_threshold - waterfallPreviousMinValue;
                                        off_set = waterfall_data - waterfallPreviousMinValue + LinLogCor;
                                        float spec_bits = 1024;
                                        overall_percent = (spec_bits * off_set) / range; // value from 0.0 to 1.0 where 1.0 is high and 0.0 is low.
                                        float log_fract = (float)(Math.Log10(spec_bits));
                                        if (overall_percent == 0)
                                        {
                                            overall_percent = (float)0.001;
                                        }
                                        overall_percent = (float)(Math.Log10(overall_percent));

                                        if (overall_percent < log_fract / 23)
                                        {
                                            //			float local_percent = overall_percent / ((float)1/23);
                                            R = 0;
                                            G = 0;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)2 * log_fract / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)1/23) / ((float)1/23);
                                            R = 32;
                                            G = 0;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)3 * log_fract / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)2/23) / ((float)1/23);
                                            R = 64;
                                            G = 0;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)4 * log_fract / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)3/23) / ((float)1/23);
                                            R = 96;
                                            G = 0;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)5 * log_fract / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)4/23) / ((float)1/23);
                                            R = 104;
                                            G = 40;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)6 * log_fract / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)5/23) / ((float)1/23);
                                            R = 112;
                                            G = 60;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)7 * log_fract / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)6/23) / ((float)1/23);
                                            R = 116;
                                            G = 88;
                                            B = 0;
                                        }


                                        else if (overall_percent < (float)8 * log_fract / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)7/23) / ((float)1/23);
                                            R = 92;
                                            G = 112;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)9 * log_fract / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)8/23) / ((float)1/23);
                                            R = 80;
                                            G = 132;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)10 * log_fract / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)9/23) / ((float)1/23);
                                            R = 20;
                                            G = 140;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)11 * log_fract / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)10/23) / ((float)1/23);
                                            R = 0;
                                            G = 160;
                                            B = 40;
                                        }
                                        else if (overall_percent < (float)12 * log_fract / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)11/23) / ((float)1/23);
                                            R = 0;
                                            G = 160;
                                            B = 120;
                                        }

                                        else if (overall_percent < (float)13 * log_fract / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)12/23) / ((float)1/23);
                                            R = 0;
                                            G = 140;
                                            B = 148;
                                        }
                                        else if (overall_percent < (float)14 * log_fract / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)13/23) / ((float)1/23);
                                            R = 0;
                                            G = 132;
                                            B = 192;
                                        }
                                        else if (overall_percent < (float)15 * log_fract / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)14/23) / ((float)1/23);
                                            R = 0;
                                            G = 112;
                                            B = 200;
                                        }
                                        else if (overall_percent < (float)16 * log_fract / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)15/23) / ((float)1/23);
                                            R = 0;
                                            G = 88;
                                            B = 208;
                                        }
                                        else if (overall_percent < (float)17 * log_fract / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)16/23) / ((float)1/23);
                                            R = 0;
                                            G = 60;
                                            B = 232;
                                        }
                                        else if (overall_percent < (float)18 * log_fract / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)17/23) / ((float)1/23);
                                            R = 0;
                                            G = 40;
                                            B = 252;
                                        }
                                        else if (overall_percent < (float)19 * log_fract / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)18/23) / ((float)1/23);
                                            R = 80;
                                            G = 80;
                                            B = 252;
                                        }

                                        else if (overall_percent < (float)20 * log_fract / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)19/23) / ((float)1/23);
                                            R = 124;
                                            G = 124;
                                            B = 252;
                                        }

                                        else if (overall_percent < (float)21 * log_fract / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)20/23) / ((float)1/23);
                                            R = 172;
                                            G = 172;
                                            B = 252;
                                        }

                                        else if (overall_percent >= (float)21 * log_fract / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)22/23) / ((float)1/23);
                                            R = 252;
                                            G = 252;
                                            B = 252;
                                        }
                                        else
                                        {
                                            R = 0;
                                            G = 0;
                                            B = 0;
                                        }
                                    }
                                    rawData[xposadj * 4] = (byte)R;  //w3sz
                                    rawData[1 + xposadj * 4] = (byte)G;  //w3sz
                                    rawData[2 + xposadj * 4] = (byte)B;  //w3sz
                                    rawData[3 + xposadj * 4] = 255;  //w3sz

                            }
                            break;

                        //  now Linrad palette without log

                        case ("LinRad"):
                            {
                                    if (waterfall_data <= waterfallPreviousMinValue)
                                    {
                                        R = 0;
                                        G = 0;
                                        B = 0;
                                    }
                                    else if (waterfall_data >= waterfall_high_threshold)
                                    {
                                        R = 252;
                                        G = 252;
                                        B = 252;
                                    }
                                    else // value is between low and high
                                    {
                                        range = waterfall_high_threshold - waterfallPreviousMinValue;
                                        off_set = waterfall_data - waterfallPreviousMinValue + LinCor;
                                        overall_percent = (off_set) / range; // value from 0.0 to 1.0 where 1.0 is high and 0.0 is low.


                                        if (overall_percent < (float)1 / 23)
                                        {
                                            //			float local_percent = overall_percent / ((float)1/23);
                                            R = 0;
                                            G = 0;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)2 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)1/23) / ((float)1/23);
                                            R = 32;
                                            G = 0;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)3 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)2/23) / ((float)1/23);
                                            R = 64;
                                            G = 0;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)4 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)3/23) / ((float)1/23);
                                            R = 96;
                                            G = 0;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)5 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)4/23) / ((float)1/23);
                                            R = 104;
                                            G = 40;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)6 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)5/23) / ((float)1/23);
                                            R = 112;
                                            G = 60;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)7 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)6/23) / ((float)1/23);
                                            R = 116;
                                            G = 88;
                                            B = 0;
                                        }


                                        else if (overall_percent < (float)8 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)7/23) / ((float)1/23);
                                            R = 92;
                                            G = 112;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)9 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)8/23) / ((float)1/23);
                                            R = 80;
                                            G = 132;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)10 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)9/23) / ((float)1/23);
                                            R = 20;
                                            G = 140;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)11 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)10/23) / ((float)1/23);
                                            R = 0;
                                            G = 160;
                                            B = 40;
                                        }
                                        else if (overall_percent < (float)12 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)11/23) / ((float)1/23);
                                            R = 0;
                                            G = 160;
                                            B = 120;
                                        }

                                        else if (overall_percent < (float)13 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)12/23) / ((float)1/23);
                                            R = 0;
                                            G = 140;
                                            B = 148;
                                        }
                                        else if (overall_percent < (float)14 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)13/23) / ((float)1/23);
                                            R = 0;
                                            G = 132;
                                            B = 192;
                                        }
                                        else if (overall_percent < (float)15 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)14/23) / ((float)1/23);
                                            R = 0;
                                            G = 112;
                                            B = 200;
                                        }
                                        else if (overall_percent < (float)16 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)15/23) / ((float)1/23);
                                            R = 0;
                                            G = 88;
                                            B = 208;
                                        }
                                        else if (overall_percent < (float)17 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)16/23) / ((float)1/23);
                                            R = 0;
                                            G = 60;
                                            B = 232;
                                        }
                                        else if (overall_percent < (float)18 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)17/23) / ((float)1/23);
                                            R = 0;
                                            G = 40;
                                            B = 252;
                                        }
                                        else if (overall_percent < (float)19 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)18/23) / ((float)1/23);
                                            R = 80;
                                            G = 80;
                                            B = 252;
                                        }

                                        else if (overall_percent < (float)20 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)19/23) / ((float)1/23);
                                            R = 124;
                                            G = 124;
                                            B = 252;
                                        }

                                        else if (overall_percent < (float)21 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)20/23) / ((float)1/23);
                                            R = 172;
                                            G = 172;
                                            B = 252;
                                        }

                                        else if (overall_percent >= (float)21 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)22/23) / ((float)1/23);
                                            R = 252;
                                            G = 252;
                                            B = 252;
                                        }
                                        else
                                        {
                                            R = 0;
                                            G = 0;
                                            B = 0;
                                        }
                                    }
                                    rawData[xposadj * 4] = (byte)R;  //w3sz
                                    rawData[1 + xposadj * 4] = (byte)G;  //w3sz
                                    rawData[2 + xposadj * 4] = (byte)B;  //w3sz
                                    rawData[3 + xposadj * 4] = 255;  //w3sz

                            }
                            break;

                        //  now Linrad palette without log

                        case ("LinAuto"):
                            {
                                    //w3sz for histogram equalization
                                    //	if (i == (W - 1))
                                    //	{
                                    //		System.Console.WriteLine("Low is" + waterfallPreviousMinValue + "   " + display_min_w3sz);
                                    //	
                                    //		System.Console.WriteLine("High is" + waterfall_high_threshold + "   " + max_y);
                                    //}	

                                    if (waterfall_data <= waterfallPreviousMinValue)
                                    {
                                        R = 0;
                                        G = 0;
                                        B = 0;
                                    }
                                    else if (waterfall_data >= waterfallPreviousMaxValue)
                                    {
                                        R = 252;
                                        G = 252;
                                        B = 252;
                                    }
                                    else // value is between low and high
                                    {
                                        range = waterfallPreviousMaxValue - waterfallPreviousMinValue;
                                        off_set = waterfall_data - waterfallPreviousMinValue; // + GlobalClass.LinCor;
                                        overall_percent = (off_set) / range; // value from 0.0 to 1.0 where 1.0 is high and 0.0 is low.


                                        if (overall_percent < (float)1 / 23)
                                        {
                                            //			float local_percent = overall_percent / ((float)1/23);
                                            R = 0;
                                            G = 0;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)2 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)1/23) / ((float)1/23);
                                            R = 32;
                                            G = 0;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)3 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)2/23) / ((float)1/23);
                                            R = 64;
                                            G = 0;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)4 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)3/23) / ((float)1/23);
                                            R = 96;
                                            G = 0;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)5 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)4/23) / ((float)1/23);
                                            R = 104;
                                            G = 40;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)6 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)5/23) / ((float)1/23);
                                            R = 112;
                                            G = 60;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)7 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)6/23) / ((float)1/23);
                                            R = 116;
                                            G = 88;
                                            B = 0;
                                        }


                                        else if (overall_percent < (float)8 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)7/23) / ((float)1/23);
                                            R = 92;
                                            G = 112;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)9 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)8/23) / ((float)1/23);
                                            R = 80;
                                            G = 132;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)10 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)9/23) / ((float)1/23);
                                            R = 20;
                                            G = 140;
                                            B = 0;
                                        }
                                        else if (overall_percent < (float)11 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)10/23) / ((float)1/23);
                                            R = 0;
                                            G = 160;
                                            B = 40;
                                        }
                                        else if (overall_percent < (float)12 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)11/23) / ((float)1/23);
                                            R = 0;
                                            G = 160;
                                            B = 120;
                                        }

                                        else if (overall_percent < (float)13 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)12/23) / ((float)1/23);
                                            R = 0;
                                            G = 140;
                                            B = 148;
                                        }
                                        else if (overall_percent < (float)14 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)13/23) / ((float)1/23);
                                            R = 0;
                                            G = 132;
                                            B = 192;
                                        }
                                        else if (overall_percent < (float)15 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)14/23) / ((float)1/23);
                                            R = 0;
                                            G = 112;
                                            B = 200;
                                        }
                                        else if (overall_percent < (float)16 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)15/23) / ((float)1/23);
                                            R = 0;
                                            G = 88;
                                            B = 208;
                                        }
                                        else if (overall_percent < (float)17 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)16/23) / ((float)1/23);
                                            R = 0;
                                            G = 60;
                                            B = 232;
                                        }
                                        else if (overall_percent < (float)18 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)17/23) / ((float)1/23);
                                            R = 0;
                                            G = 40;
                                            B = 252;
                                        }
                                        else if (overall_percent < (float)19 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)18/23) / ((float)1/23);
                                            R = 80;
                                            G = 80;
                                            B = 252;
                                        }

                                        else if (overall_percent < (float)20 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)19/23) / ((float)1/23);
                                            R = 124;
                                            G = 124;
                                            B = 252;
                                        }

                                        else if (overall_percent < (float)21 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)20/23) / ((float)1/23);
                                            R = 172;
                                            G = 172;
                                            B = 252;
                                        }

                                        else if (overall_percent >= (float)21 / 23)
                                        {
                                            //			float local_percent = (overall_percent - (float)22/23) / ((float)1/23);
                                            R = 252;
                                            G = 252;
                                            B = 252;
                                        }
                                        else
                                        {
                                            R = 0;
                                            G = 0;
                                            B = 0;
                                        }
                                    }
                                    rawData[xposadj * 4] = (byte)R;  //w3sz
                                    rawData[1 + xposadj * 4] = (byte)G;  //w3sz
                                    rawData[2 + xposadj * 4] = (byte)B;  //w3sz
                                    rawData[3 + xposadj * 4] = 255;  //w3sz

                            }
                            break;
                    }

                    // Find the lowest signal level in the block of 1024 samples. If the automatic check box
                    // is selected then use this value for waterfall_waterfallPreviousMinValue next time through.
                    if (waterfall_minimum > waterfall_data) 
                    {
                        waterfall_minimum = waterfall_data;
                    }
                    
                if (waterfall_maximum < waterfall_data)
                {
                    waterfall_maximum = waterfall_data;
                }

                // Find the maximum signal level in the block of 1024 samples for use in the wideband squelch
       //         if (bandscopeSquelch &&  xpos > 0 && max_signal < (nPS - logGain)) //TODO: sample 0 is always 85 - why?
        //            max_signal = (nPS - logGain);
                    if ((max_signal < yy[xpos]) & (xpos > 0))  //w3sz
                    {
                        max_signal = Convert.ToInt32(yy[xpos]);  //w3sz
                        xpos_max = xpos;  //w3sz
                    }

                    if ((min_signal > yy[xpos]) & (xpos > 0))  //w3sz
                {
                    min_signal = Convert.ToInt32(yy[xpos]);  //w3sz
                    xpos_min = xpos;  //w3sz
                }

                
            }     // end for each xpos data point section

                  // copy the rawData buffer to the Bitmap, the fast way.  This uses Bitmap.LockBits and Marshal.Copy.
            try
            {
                lock (_waterfallLockObj)
                {
                    Rectangle drawRect = new Rectangle(0, currentWaterfallLine, xWidth, 1);
                    System.Drawing.Imaging.BitmapData rawBmpData = waterfallBitmap.LockBits(drawRect,
                    System.Drawing.Imaging.ImageLockMode.WriteOnly, waterfallBitmap.PixelFormat);
                    System.Runtime.InteropServices.Marshal.Copy(rawData, 0, rawBmpData.Scan0, 4 * xWidth);
                    waterfallBitmap.UnlockBits(rawBmpData);

                    rawData = null;

                    // Now store the waterfall_minumum value, so that it is available for the next packet to use
                    // Provide  some 'history' (smoothing) in the WaterfallAGC i.e. 80% of the previous value and 20% of the current
                    waterfallPreviousMinValue = ((waterfallPreviousMinValue * 8) + (waterfall_minimum * 2)) / 10.0f;
                    waterfallPreviousMaxValue = ((waterfallPreviousMaxValue * 8) + (waterfall_maximum * 2)) / 10.0f;
                }
            }
            catch (Exception e)
            {
                Console.WriteLine(e.ToString());
                ClearWaterfall();
            }
        }

        //++++++++++++++++++++++++++++++++++++++++++++++++  end ComputeDisplay()

        
        private int currentWaterfallLine = 0;
        private int numWaterfallLines = 0;

        private void ClearWaterfall()
        {
            currentWaterfallLine = 0;
            numWaterfallLines = 0;
        }
        
        Int32[] blackness = null;

        private void NextWaterfallLine()
        {
            try
            {
                lock (_waterfallLockObj)
                {
                    if (--currentWaterfallLine < 0)
                    {
                        currentWaterfallLine = waterfallBitmap.Height - 1;
                    }

                    if (numWaterfallLines < waterfallBitmap.Height)
                    {
                        ++numWaterfallLines;
                    }
                }
            }
            catch (Exception e)
            {
                Console.WriteLine(e.ToString());
                ClearWaterfall();
            }

            if (numWaterfallLines == 1)
            {
#if true
                // about to make first use!  set all to black!
                int width = waterfallBitmap.Width;
                int height = waterfallBitmap.Height;
                int length = width * height;

                if (blackness == null)
                {
                    // first create a row describing "black"
                    blackness = new Int32[length];
                    int idx;
                    for (idx = 0; idx < length; idx++)
                    {
                        blackness[idx] = unchecked((Int32)0xFF000000); // R=0, G=0, B=0, A=255
                    }
                }

                try
                {
                    lock (_waterfallLockObj)
                    {
                        // now gain raw access to the bitmap
                        Rectangle drawRect = new Rectangle(0, 0, width, height);  // w3sz  was 0,0,width,height
                        System.Drawing.Imaging.BitmapData rawBmpData = waterfallBitmap.LockBits(drawRect,
                        System.Drawing.Imaging.ImageLockMode.WriteOnly, waterfallBitmap.PixelFormat);

                        System.Runtime.InteropServices.Marshal.Copy(blackness, 0, rawBmpData.Scan0, length);

                        // we're done, no more need for raw access
                        waterfallBitmap.UnlockBits(rawBmpData);
                    }
                }
                catch (Exception e)
                {
                    Console.WriteLine(e.ToString());
                    ClearWaterfall();
                }

#else
                waterfallBitmap = new Bitmap(1024, 144, System.Drawing.Imaging.PixelFormat.Format32bppPArgb); //was 1024,256  w3sz.
#endif
            }
        }

     
        private static SolidBrush pana_text_brush = new SolidBrush(Color.Khaki);
        private static Font pana_font = new Font("Tahoma", 7F, FontStyle.Regular, GraphicsUnit.Point, ((byte)(0)));

        private int dBToPixel(double dB)
        {
            return Convert.ToInt32((GridMax - dB) * pixels_per_GridStep / GridStep);
        }

        private double PixelToDb(int y)
        {
            double dB = (double)y * GridStep / pixels_per_GridStep;

            return GridMax - dB;
        }

        private int dBToPixelContinuous(double dB)
        {
            return Convert.ToInt32((GridMax - dB) * pixelsperdB);
        }

        private void DrawSpectrumGrid(Graphics g)
        {
            #region How DrawGrid works
            /* 
             * We want to display a grid spaced 5/10/20kHz apart horizontally depending on the sampling rate.
             * We also want to display a vertical grid spaced zdB apart. We also want to indicate the 
             * current filter width on the display.
             * 
             * The screenwidth xWidth is 1024 pixels wide. 
             * Filter width in bins =  bandwidth / sampling_rate
             * Filter width in pixels = (bw/SR) * (pixels/bin)
             * So Filter width in pixels = (bw * xWidth)/(SR * FFTSize)
             * 
             * To display the grid, first calculate the vertical grid spacing. We want to display from +/-XdB to -YdBm in ZdB steps 
             * which means we need 160/20 = 8 horizontal lines.
             * (numberof)Lines = (dB range)/(dB step size)
             * 
             * We know the frequency at the left hand edge of the bandscope since IF THERE IS NO ZOOM it will be the tuned frequency less 
             * (sampling rate/2).  This will be displayed at the top of the first vertical grid line. We want the vertical 
             * grid to have spacings of 5/10/20kHz depending on the sampling rate. We also want the frequency markings to
             * be in these increments. So we need to find the first location from the left hand side of the screen that we
             * can divide by 5/10/20 and get no remainder.  We use the % function to do this. 
             * 
             * If there is zoom, then in the above explanation "sampling rate" needs to be replaced by FreqSpan, which is
             * SampleRate * FFTPerCent, where FFTPerCent is the fraction of the FFT that is displayed in the zoomed-in window.
             * 
             * Since the minimium grid size is 5kHz we are going to have to test in finer increments than this such that
             * frequency/5 = 0 remainder.  So we use 100Hz increments - this gives a nice smooth display when we drag it.
             * 
             * Once we know the first frequency from the left hand edge of the bandscope we can convert this to pixels. 
             * We know the bandscope is 1024 pixels wide and the frequency width = sampling rate. So we can calculate the x 
             * location of the first vertical bar from  
             * 
             *  pixel_indent = Hz offset from LHS * width of bandscope/sample rate
             *  
             * We can now format the frequency text and display the lines. 
             * 
             * 
             */

            #endregion

            // get the height of our panel

            if ((Globals.main222 == false) & (Globals.aux222 == false))
            {
                BSHeight = Globals.boxsmallsize.Height/2;
            }
            else
            {
                BSHeight = Globals.boxlargesize.Height / 2;
            }


            // calculate the number of horizontal lines and the distance between them
            double lines = (double)(GridMax - GridMin) / (double)GridStep;
            lines = Math.Ceiling((double)lines); // if lines is a fraction round up to next integer 
            int x_locate = 0;
            string displayFreq;
            long display_frequency = 0;
            int offset = 15; // how many pixels from the top to start drawing the vertical lines
            Font font;

            int pixel_spacing;
            double pixels_per_100Hz;
            int grid_spacing;

            // determine vertical grid spacing
            int vertical_grid_spacing = Convert.ToInt32(BSHeight / lines);
            pixels_per_GridStep = vertical_grid_spacing;
            pixelsperdB = BSHeight /(double)(GridMax - GridMin); 

            // determine horizontal grid spacing

            if (FreqSpan != 0)
            {
                if (FreqSpan >= 129000)
                {
                    grid_spacing = 200;
                    pixel_spacing = Convert.ToInt32(pictureBox1.Width * grid_spacing * 100 / FreqSpan);  // how many pixels this spacing represents
                    pixels_per_100Hz = pictureBox1.Width * 100.0f / FreqSpan; // how many pixels per 100Hz across the screen 
                }
                else if (FreqSpan >= 86000)
                {
                    grid_spacing = 150;
                    pixel_spacing = Convert.ToInt32(pictureBox1.Width * grid_spacing * 100 / FreqSpan);  // how many pixels this spacing represents
                    pixels_per_100Hz = pictureBox1.Width * 100.0f / FreqSpan; // how many pixels per 100Hz across the screen 
                }
                else if (FreqSpan >= 43000)
                {
                    grid_spacing = 100;
                    pixel_spacing = Convert.ToInt32(pictureBox1.Width * grid_spacing * 100 / FreqSpan);  // how many pixels this spacing represents
                    pixels_per_100Hz = pictureBox1.Width * 100.0f / FreqSpan; // how many pixels per 100Hz across the screen 
                }
                else if (FreqSpan >= 17200)
                {
                    grid_spacing = 50;
                    pixel_spacing = Convert.ToInt32(pictureBox1.Width * grid_spacing * 100 / FreqSpan);  // how many pixels this spacing represents
                    pixels_per_100Hz = pictureBox1.Width * 100.0f / FreqSpan; // how many pixels per 100Hz across the screen 
                }
                else if (FreqSpan >= 8600)
                {
                    grid_spacing = 20;
                    pixel_spacing = Convert.ToInt32(pictureBox1.Width * grid_spacing * 100 / FreqSpan);  // how many pixels this spacing represents
                    pixels_per_100Hz = pictureBox1.Width * 100.0f / FreqSpan; // how many pixels per 100Hz across the screen 
                }
                else
                {
                    grid_spacing = 10;
                    pixel_spacing = Convert.ToInt32(pictureBox1.Width * grid_spacing * 100 / FreqSpan);  // how many pixels this spacing represents
                    pixels_per_100Hz = pictureBox1.Width * 100.0f / FreqSpan; // how many pixels per 100Hz across the screen 
                }
            }
            else
            {
               grid_spacing = Convert.ToInt32(SampleRate / 960.0d);  // gives 50/100/200 x 100Hz
               pixel_spacing = Convert.ToInt32(pictureBox1.Width * grid_spacing * 100.0d / (double)SampleRate);  // how many pixels this spacing represents
               pixels_per_100Hz = pictureBox1.Width * 100.0d /(double)SampleRate; // how many pixels per 100Hz across the screen 
               Console.WriteLine("FreqSpan = 0!!!");
            }

            // Draw the background color
            //      g.FillRectangle(Brushes.DarkGreen, pictureBox1.ClientRectangle);
            g.FillRectangle(Brushes.DarkGreen, 0, 0, 1024, BSHeight);

            if ((Globals.main222 == false) & (Globals.aux222 == false))
            {
                font = new Font(FontFamily.GenericMonospace, 8);
            }
            else
            {
                font = new Font(FontFamily.GenericMonospace, 12);
            }

            // if the narrow bandscope is selected display it


            long left_edge_frequency; 

            // Show the  filter bandwidth on the screen 
            // The screen is 1024 pixels wide so filter width =  bandwidth / sampling_rate
            if (FreqSpan != 0)
            {
                FilterLeft = (pictureBox1.Width)/2  + (long)(pictureBox1.Width * Math.Min(FilterFrequencyLow, FilterFrequencyHigh) /(FreqSpan));
                FilterRight = (pictureBox1.Width) / 2 + (long)(pictureBox1.Width * Math.Max(FilterFrequencyLow, FilterFrequencyHigh) / (FreqSpan));
            }
            else
            {
                FilterLeft = (pictureBox1.Width) / 2 + (long)(pictureBox1.Width * Math.Min(FilterFrequencyLow, FilterFrequencyHigh) / (double)SampleRate);
                FilterRight = (pictureBox1.Width) / 2 + (long)(pictureBox1.Width * Math.Max(FilterFrequencyLow, FilterFrequencyHigh) / (double)SampleRate);

            } 
            long Width = FilterRight - FilterLeft;

            // Draw the filter bandwidth in a different colour
            g.FillRectangle(Brushes.SeaGreen, FilterLeft, 0, Width, BSHeight);

            // truncate tuned frequency to 100Hz digits 
            xvtr_frequency = set_frequency.Value + LO + LOoffset;
            long truncate_freq = (long)((xvtr_frequency)  / 100.0d);

            // the frequency at the left edge of the screen will be the tuned frequency - sample rate/(2 x 100Hz)
            if (FreqSpan != 0)
            {
                left_edge_frequency = (long)(truncate_freq - FreqSpan / 200d);
            }
            else
            {
                left_edge_frequency = (long)( truncate_freq - SampleRate / 200d);
            }
            // we now step in from the left edge frequency until we have a frequency that divides by 
            // the grid spacing with no remainder. This will be the first frequency we display
            for (display_frequency = left_edge_frequency; display_frequency < truncate_freq - 12; display_frequency++)
            {
                if ((display_frequency % grid_spacing) == 0)
                    break;
            }

            // how many pixels is this from the left edge of the screen
            double indent_pixels = (display_frequency - left_edge_frequency) * pixels_per_100Hz;

            // draw the vertical grid lines with their associated frequency
            for (double i = indent_pixels; i < pictureBox1.Width; i += pixels_per_100Hz)
            {
                if (display_frequency % grid_spacing == 0)  // are we on a grid boundry
                {
                    // draw the vertical lines
                    g.DrawLine(Pens.DarkGray,Convert.ToInt64(i), offset, Convert.ToInt64(i), BSHeight); // offset stops the line going through the text
               
                        displayFreq = String.Format("{0:0.000}", (double)display_frequency / 10000);
                        if (display_frequency < 100000)  // so the decimal point in the frequency aligns with the grid line - perfectionist!
                            x_locate = Convert.ToInt32(i - 17);
                        else
                            x_locate = Convert.ToInt32(i - 26);
                        // draw the text above each line
                        g.DrawString(displayFreq, font, Brushes.White, x_locate, 0);
                }
                // highlight band edge in Red
                if ((display_frequency == set_frequency.Minimum / 100) || (display_frequency == set_frequency.Maximum / 100))
                    g.DrawLine(Pens.Red,(float) i, offset,(float)i, (float)BSHeight);

                display_frequency++; // increment frequency in 100s of Hz 
            }

            // draw a single vertical line in the middle of the screen
            g.DrawLine(Pens.Yellow, pictureBox1.Width / 2, offset, pictureBox1.Width / 2, BSHeight);

            // Draw the horizontal lines and signal calibration 
            // First draw the horizontal lines so they don't cover the calibration text 
            // Only draw them for the narrow bandscope
            for (int k = 0; k < BSHeight; k += vertical_grid_spacing)
            {
                g.DrawLine(Pens.DarkGray, 0, k, pictureBox1.Width, k);
            }

            // The dBm value for the top of the screen is held in Grid.Max, we don't indicate this but we do the next line
            // This will be Grid.Max - Grid.Step
            int textSpacing = vertical_grid_spacing;
            for (int x = GridMax - GridStep; x > GridMin; x -= GridStep)
            {
                string level = x.ToString() + "dBm";
                g.DrawString(level, font, Brushes.White, 0, textSpacing - 9);
                textSpacing += vertical_grid_spacing;
            }
        
            // end DoSpectrum = true;

            // Draw horizontal lines  if we need to show I or Q and no bandscope is selected

            // draw cross if required, only used on narrow bandscope at the moment. 
            if (ShowCross)
            {
                g.DrawLine(Pens.Yellow, MousePositionX, 0, MousePositionX, BSHeight); // draw cross vertical line
                if (MousePositionY < BSHeight)  // with both displays check we are within the screen boundries
                    g.DrawLine(Pens.Yellow, 0, MousePositionY, pictureBox1.Width, MousePositionY); // draw cross horizontal line
            }
        }

        private void RefreshSpectrumScope(Graphics g)
        {
            try
            {
                if (bandDraw != null) g.DrawCurve(WhitePen, bandDraw);
            }
            catch
            {
                Console.WriteLine("Spectrum Scope try fail at line 1836");
            }
            // set the range of the squelch contol to the max and min bandscope values x10 to give high resolution
            Squelch_level.Minimum = GridMin * 10; Squelch_level.Maximum = GridMax * 10;

            if (filterSquelch || bandscopeSquelch)
            {
                squelch_y_value = Convert.ToInt32(-((Squelch_level.Value / 10) - (GridMax)) * pixels_per_GridStep / GridStep);
                
                // draw dotted line to represent squelch threshold
                g.DrawLine(dotPen, 0, squelch_y_value, pictureBox1.Width - 1, squelch_y_value);

                // draw the little rectangle at the left side of the squelch threshold line
                squelch.Height = 10; squelch.Width = 10; squelch.X = 0;
                squelch.Y = squelch_y_value - squelch.Height / 2; // make it a square
                g.FillRectangle(Brushes.DarkOrange, squelch);   // fill the rectangle with colour
            }
        }
        
        // format changed to PArgb (rgb values pre-multiplied by A.  Since A is 255 (max), regular RGB counts as 'pre-multiplied'.
        
         
        private Bitmap waterfallBitmap = new Bitmap(1024, 144, System.Drawing.Imaging.PixelFormat.Format32bppPArgb);
   //    private Bitmap waterfallBitmap = new Bitmap("test.png"); 
        private void RefreshWaterFall(Graphics g)  //waterfall 
        {
            try
            {
                int height;
                int width;
                Size size;

          
                if ((Globals.main222 == false) & (Globals.aux222 == false))
                {
                    height = Globals.boxsmallsize.Height/2;
                    width = Globals.boxsmallsize.Width;
                    size = Globals.boxsmallsize;
                }
                else
                {
                    height = Globals.boxlargesize.Height/2;
                    width = Globals.boxlargesize.Width;
                    size = Globals.boxlargesize;
                }
                // display the waterfall bitmap, if we have one
                // display it in two parts: from the currentWaterfallLine to the end of the array,
                // 
                if (waterfallBitmap != null)
                {
                    lock (_waterfallLockObj)
                    {
                        int firstLine = currentWaterfallLine;
                        int firstSegmentLength = waterfallBitmap.Height - currentWaterfallLine;
                        Rectangle destRect = new Rectangle(0, height, 1024, firstSegmentLength); //w3sz was 0,0,1024...

                        // Create rectangle for source image.  This is the first part, from currentWaterfallLine to the end of the bitmap
                        Rectangle srcRect = new Rectangle(0, currentWaterfallLine, 1024, firstSegmentLength); //was 0, currentwaterfall line,1024
                        GraphicsUnit units = GraphicsUnit.Pixel;
                        // Draw image to screen, part 1.
                        g.DrawImage(waterfallBitmap, destRect, srcRect, units);  //original

                        // draw rest of the image (which may be blank/black) which is the FIRST PART of the bitmap, to AFTER where
                        // the first part was drawn
                        destRect.Y = firstSegmentLength + height;
                        destRect.Height = currentWaterfallLine;
                        srcRect.Y = 0;
                        srcRect.Height = currentWaterfallLine;
                        g.DrawImage(waterfallBitmap, destRect, srcRect, units);  //original
                    }                                                         //
                }
            }
            catch (Exception e)
            {
                Console.WriteLine(e.ToString());
                ClearWaterfall();
            }
            // end try
        }

          
        
        void DrawSMeterBackground(Graphics sg)
        {
            sg.FillRectangle(Brushes.Black, 0, 0, pictureBox3.Width, pictureBox3.Height);
            float MeterHeigth = pictureBox3.Height - 3;
            float MeterWidth = pictureBox3.Width - 5;
            pictureBox3.BackColor = Color.Black;
            Brush whiteBrush = Brushes.White;
            Brush redBrush = Brushes.Red;
            Pen whitePen = new Pen(Color.White, 2);
            Pen narrowWhitePen = new Pen(Color.White, 1);
            Pen redPen = new Pen(Color.Red, 2);
            Pen narrowRedPen = new Pen(Color.Red, 1);
            float MarkerSpacing = 14; // Meter.Width / 10.0f;
            string marker = null;

            // Draw the white items
            for (float x = 5, y = 12, z = 1; x < pictureBox3.Width / 2; x += MarkerSpacing, y += MarkerSpacing, z += 2)
            {
                marker = z.ToString();
                sg.DrawLine(narrowWhitePen, x, MeterHeigth, x, 0.9f * MeterHeigth); //small ticks
                sg.DrawLine(whitePen, y, MeterHeigth, y, 0.8f * MeterHeigth); //big ticks
                sg.DrawString(marker, meterFont, whiteBrush, y - 5, 0.45f * MeterHeigth);
            }

            // Draw the red items
            MarkerSpacing = 22; // Meter.Width / 6.5f;  // wider spacing for these itesm 

            for (float x = 67 + MarkerSpacing / 2, y = 67 + MarkerSpacing, z = 0; x < pictureBox3.Width; x += MarkerSpacing, y += MarkerSpacing, z++)
            {
                if (z == 0) marker = "+20";
                else if (z == 1) marker = "+40";
                else if (z == 2) marker = "+60";
                sg.DrawLine(narrowRedPen, x, MeterHeigth, x, 0.9f * MeterHeigth); //small ticks
                sg.DrawLine(redPen, y, MeterHeigth, y, 0.8f * MeterHeigth); //big ticks
                sg.DrawString(marker, meterFont, redBrush, y - 10, 0.45f * MeterHeigth);
            }

            // Draw horizontal lines to finish off
            sg.DrawLine(whitePen, 0, MeterHeigth, MeterWidth / 2, MeterHeigth);
            sg.DrawLine(redPen, 1 + MeterWidth / 2, MeterHeigth, MeterWidth - 1, MeterHeigth);
        }

        Image SMeterBackgroundImage;

        // Draw the SMeter and display the signal level
        void pictureBox3_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
        {
            Graphics g = e.Graphics;

            // We only need to draw the SMeter backrough once, then use it as an image 
            // saves CPU cycles

            if (SMeterBackgroundImage == null)
            {
                SMeterBackgroundImage = new Bitmap(pictureBox3.Width, pictureBox3.Height);
                Graphics sg = Graphics.FromImage(SMeterBackgroundImage);

                DrawSMeterBackground(sg);

                pictureBox3.BackgroundImage = SMeterBackgroundImage;
            }
            else
            {
            }

            // now draw SMeter value as a vertical bar
            // scale below S9 is 7 pixels per marker and 11 above so need to scale accordingly
            Pen yellowPen = new Pen(Color.Yellow, 2);
            SMeterValue = Convert.ToInt32((float)SMeterReceived * 1.15f) - 10;
            if (SMeterValue > 68)  // scale changes at the S9 level
                SMeterValue = Convert.ToInt32((float)SMeterValue * 0.98f);
            g.DrawLine(yellowPen, SMeterValue, 0, SMeterValue, pictureBox3.Height);  // should remove /2; just there for testing
        }

        // Slider control sets transceiver center frequency
        public void set_frequency_Scroll_1(object sender, EventArgs e)
        {
            // when the frequency slider has focus the mouse scroll wheel
            // can be used to increment the frequency by +/- step_size.

            // the scroll bar can also be moved with the arrow and Up/Down keys 
            // make the scroll bar large and small step sizes a function of the step size 
            set_frequency.LargeChange = ((step_size + 1) * 100) - step_size;
            set_frequency.SmallChange = (step_size + 1);

            // check we are still within the band and update the tune and display frequencies
            Frequency_change();
            UpdateGraphs();
        }


        // replaces set_frequency_scroll when setting frequency via COM port
        public void Autoset_frequency_Scroll_1(object sender, EventArgs e)
        {

            AutoFrequency_change();
            UpdateGraphs();
        }


        //replaces Frequency_change for frequency changes via COM port
        private void AutoFrequency_change()
        {
            // display the new frequency and send to Ozy  
            DisplayFrequency(set_frequency.Value);
            // save current value so we can compare with next value so we can determine tune direction
            previous_frequency_value = set_frequency.Value;

            //send to server, added by W3SZ

            byte[] textstrng = StrToByteArray("freq" + set_frequency.Value.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked222)

            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider
            }
        }

        // select the step size that the mouse scroll wheel does
        private void stepSize_SelectedIndexChanged(object sender, EventArgs e)
        {
            // since we have already taken a step use (step size - 1)
            // TODO: this works OK for the mousewheel on my mouse but check this is universal
            switch (stepSize.Text)
            {
                case "1Hz": step_size = 0; break;
                case "10Hz": step_size = 9; break;
                case "100Hz": step_size = 99; break;
                case "1kHz": step_size = 999; break;
            }

            byte[] textstrng = StrToByteArray("step" + stepSize.Text); //w3sz  convert to byte array
            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider
            }
        }
        
        public static byte[] StrToByteArray(string str)
        {
            System.Text.UTF8Encoding encoding = new System.Text.UTF8Encoding();
            return encoding.GetBytes(str);
        }

        private void Mode_SelectedIndexChanged(object sender, EventArgs e)
        {
            ChangeMode(); // select filter setting based on mode
            Properties.Settings.Default.Mode222 = Mode.SelectedIndex;
            Properties.Settings.Default.Save();
            set_frequency.Focus(); // return focus to the frequency slider
        }

        private void ChangeMode() // ChangeMode() is called by Mode/BandSelect_SelectedIndexChanged()
        {
            ModeText = Mode.Text;

            switch (Mode.Text)
            {
                case "AM":  // this is 'regular' AM, not Synchronous AM (SharpDSP2._1.DSPMode_e.SAM)
                    CurrentMode = OperMode.AM;
                    BandwidthTrackBar.Minimum = 3000;
                    BandwidthTrackBar.Maximum = 12000;
                    BandwidthTrackBar.Value = BandwidthAMvalue;
                    FilterFrequencyHigh = BandwidthTrackBar.Value;
                    FilterFrequencyLow = -BandwidthTrackBar.Value;
                    BandwidthTrackBar_ValueChanged(this, EventArgs.Empty);
                    break;

                case "FM":
                    CurrentMode = OperMode.FM;
                    BandwidthTrackBar.Minimum = 3000;
                    BandwidthTrackBar.Maximum = 12000;
                    BandwidthTrackBar.Value = BandwidthFMvalue;
                    FilterFrequencyHigh = BandwidthTrackBar.Value;
                    FilterFrequencyLow = -BandwidthTrackBar.Value;
                    BandwidthTrackBar_ValueChanged(this, EventArgs.Empty);
                    break;

                case "SAM":
                    CurrentMode = OperMode.SAM;
                    BandwidthTrackBar.Minimum = 3000;
                    BandwidthTrackBar.Maximum = 12000;
                    BandwidthTrackBar.Value = BandwidthSAMvalue;
                    FilterFrequencyHigh = BandwidthTrackBar.Value;
                    FilterFrequencyLow = -BandwidthTrackBar.Value;
                    BandwidthTrackBar_ValueChanged(this, EventArgs.Empty);
                    break;

                case "USB":
                    CurrentMode = OperMode.USB;
                    BandwidthTrackBar.Minimum = 1200;
                    BandwidthTrackBar.Maximum = 6000;
                    BandwidthTrackBar.Value = BandwidthSBvalue;
                    FilterFrequencyHigh = BandwidthTrackBar.Value;
                    FilterFrequencyLow = 200.0f;
                    BandwidthTrackBar_ValueChanged(this, EventArgs.Empty);
                    break;

                case "LSB":
                    CurrentMode = OperMode.LSB;
                    BandwidthTrackBar.Minimum = 1200;
                    BandwidthTrackBar.Maximum = 6000;
                    BandwidthTrackBar.Value = BandwidthSBvalue;
                    FilterFrequencyHigh = -BandwidthTrackBar.Value;
                    FilterFrequencyLow = -200.0f;
                    BandwidthTrackBar_ValueChanged(this, EventArgs.Empty);
                    break;

                case "CWL":
                    CurrentMode = OperMode.CWL;
                    BandwidthTrackBar.Minimum = 25;
                    BandwidthTrackBar.Maximum = 1100;
                    BandwidthTrackBar.Value = BandwidthCWvalue;
                    FilterFrequencyHigh = -(Globals.CWPitch + BandwidthTrackBar.Value / 2);
                    FilterFrequencyLow = -(Globals.CWPitch - BandwidthTrackBar.Value / 2);
                    BandwidthTrackBar_ValueChanged(this, EventArgs.Empty);
                    break;

                case "CWU":
                    CurrentMode = OperMode.CWU;
                    BandwidthTrackBar.Minimum = 25;
                    BandwidthTrackBar.Maximum = 1100;
                    BandwidthTrackBar.Value = BandwidthCWvalue;
                    FilterFrequencyHigh = (Globals.CWPitch + BandwidthTrackBar.Value / 2);
                    FilterFrequencyLow = (Globals.CWPitch - BandwidthTrackBar.Value / 2);
                    BandwidthTrackBar_ValueChanged(this, EventArgs.Empty);
                    break;
					
				default:
					return;
					break;
            }

            labelFilterWidth.Text = BandwidthTrackBar.Value.ToString();

            byte[] textstrng = StrToByteArray("mode" + ModeText); //w3sz  convert to byte array

            byte[] labeltextstrng = StrToByteArray("FiWi" + labelFilterWidth.Text); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                sendCommandAsync(labeltextstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider
            }
        }

        // set the volume based on the VolumeTrackBar value
        public void SetVolume(object sender, EventArgs e)
        {
            // set the Receiver volume level
            setVolumeSquelched();
            set_frequency.Focus(); // return focus to the frequency slider
        }

        public void setVolumeSquelched()
        {
            // if squelch it turned on, AND 'squelched' is true, OR (MOX is set OR PTT set ) AND not full Duplex then mute audio
            if ((squelchOn && squelched) || ((MOX_set || PTT) && !Duplex))
            {
                VolumeLeft = 0;  // send to SharpSDP
                VolumeRight = 0;
            }
            else
            {
                // otherwise set to volume trackbar level
                // convert the track bar value to a float in the range 0 to 1, since that's what SharpDSP needs
                float v = (float)VolumeTrackBar.Value / (float)VolumeTrackBar.Maximum;
                VolumeLeft = v;  // send to SharpSDP
                VolumeRight = v;
           }

            byte[] textstrng = StrToByteArray("rvol" + VolumeLeft.ToString()); //w3sz  convert to byte array

            byte[] righttextstrng = StrToByteArray("lvol" + VolumeRight.ToString()); //w3sz  convert to byte array


            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                sendCommandAsync(righttextstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider
            }
        }
        
        public void SafeUpDownValueChange(decimal newValue, NumericUpDown control)
        {
            if (newValue < control.Minimum)
                newValue = control.Minimum;
            if (newValue > control.Maximum)
                newValue = control.Maximum;

            control.Value = newValue;
        }

        public void SafeTrackBarValueChange(int newValue, TrackBar control)
        {
            if (newValue < control.Minimum)
                newValue = control.Minimum;
            if (newValue > control.Maximum)
                newValue = control.Maximum;

            control.Value = newValue;
        }

        // set the AGC Gain  based on the AGC TrackBar value
        bool noAGCTrackBarUpdate = false;
        private void AGCTrackBar_Scroll(object sender, EventArgs e)
        {

            byte[] textstrng = StrToByteArray("AGCM" + AGCTrackBar.Value.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);              
                set_frequency.Focus(); // return focus to the frequency slider
            }
        }


        public void UpdateMaxGainAndSlider(double newGain)
        {
            noAGCTrackBarUpdate = true;
            SafeTrackBarValueChange(Convert.ToInt32(newGain), AGCTrackBar);
            noAGCTrackBarUpdate = false;
        }
        

        /// <summary>
        /// used to get/set the dB level on the spectral (panadapter) display
        /// </summary>
    

        // Set the AGC speed based on the user selection 
        private void AGCSpeed_SelectedIndexChanged(object sender, EventArgs e)
        {
            byte[] textstrng = StrToByteArray("AGCS" + AGCSpeed.Text); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider
            }
        }

        
        private void UpdateAGCTimeDisplay()
        {
   //         if (SetupForm222Valid())
            {
  //              Setup_form222.CustomRXAGCEnabled = (AGCMode == SharpDSP2._1.AGCType_e.agcUser);
   //             Setup_form222.ChangeAGCTimes();
            }
        }

        // helper function to set TX filter bandwidth
        public void SetTXFilterBandwidth()
        {
          
        }

        int BandwidthSBvalue = 2300;
        int BandwidthCWvalue = 1000;
        int BandwidthAMvalue = 5000;
        int BandwidthSAMvalue = 5000;
        int BandwidthFMvalue = 5000;

        // select the appropriate filter bandwidth for the Mode selected 
        public void AdjustFilterByMode()
        {
            SetTXFilterBandwidth();

            switch (Mode.Text)
            {
                case "LSB":
                    BandwidthSBvalue = BandwidthTrackBar.Value;
                    FilterFrequencyHigh = -BandwidthSBvalue;
                    FilterFrequencyLow = -200.0f;
                    break;

                case "USB":
                    BandwidthSBvalue = BandwidthTrackBar.Value;
                    FilterFrequencyHigh = BandwidthTrackBar.Value;
                    FilterFrequencyLow = 200.0f;
                    break;

                case "CWL":
                    BandwidthCWvalue = BandwidthTrackBar.Value;
                    FilterFrequencyHigh = -(Globals.CWPitch + BandwidthCWvalue / 2);
                    FilterFrequencyLow = -(Globals.CWPitch - BandwidthCWvalue / 2);
                    break;

                case "CWU":
                    BandwidthCWvalue = BandwidthTrackBar.Value;
                    FilterFrequencyHigh = (Globals.CWPitch + BandwidthCWvalue / 2);
                    FilterFrequencyLow = (Globals.CWPitch - BandwidthCWvalue / 2);
                    break;

                case "AM":
                    BandwidthAMvalue = BandwidthTrackBar.Value;
                    FilterFrequencyHigh = BandwidthAMvalue;
                    FilterFrequencyLow = -BandwidthAMvalue;
                    break;

                case "SAM":
                    BandwidthSAMvalue = BandwidthTrackBar.Value;
                    FilterFrequencyHigh = BandwidthSAMvalue;
                    FilterFrequencyLow = -BandwidthSAMvalue;
                    break;

                case "FM":
                    BandwidthFMvalue = BandwidthTrackBar.Value;
                    FilterFrequencyHigh = BandwidthFMvalue;
                    FilterFrequencyLow = -BandwidthFMvalue;
                    break;
            }
        }

        // Vary the filter Bandwidth when the Bandwidth control is changed
        public void BandwidthTrackBar_Scroll(object sender, EventArgs e)
        {
            AdjustFilterByMode();
            set_frequency.Focus(); // return focus to the frequency slider
            labelFilterWidth.Text = BandwidthTrackBar.Value.ToString();

            byte[] textstrng = StrToByteArray("FiWi" + labelFilterWidth.Text); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked222)
            
                {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider
            }
        }

        private void BandwidthTrackBar_ValueChanged(object sender, EventArgs e)
        {
            labelFilterWidth.Text = BandwidthTrackBar.Value.ToString();
        }

     
        // set up the Automatic Notch Filter  //have to name if NN10 because ANF0 doesn't work with "F" in "False"
        private void ANF_CheckedChanged(object sender, EventArgs e)
        {
                         
            byte[] textstrng = StrToByteArray("NN10" + ANF.Checked.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider
            }
        }


        // set up the Noise Reduction 
        private void NR_CheckedChanged(object sender, EventArgs e)
        {
            byte[] textstrng = StrToByteArray("NR11" + NR.Checked.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider
            }
        }

        // Noise Blanker1
        private void NB1_CheckedChanged(object sender, EventArgs e)
        {
            byte[] textstrng = StrToByteArray("NB10" + NB1.Checked.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider
            } 
        }

        // Noise Blanker2
        private void NB2_CheckedChanged(object sender, EventArgs e)
        {
            byte[] textstrng = StrToByteArray("NB20" + NB2.Checked.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider
            }
        }

        
        public void UpdateGraphs()
        {
            pictureBox1.Invalidate();           
        }


        private void Frequency_change()
        {
            // we need to check if we are too close to the band edge to take a step 
            if (set_frequency.Value > previous_frequency_value && set_frequency.Value < (set_frequency.Maximum - step_size))
                set_frequency.Value += step_size;  // add step_size since scroll wheel has added 1 already
            else if (set_frequency.Value < previous_frequency_value && set_frequency.Value > (set_frequency.Minimum + step_size + 1))
                set_frequency.Value -= step_size; // subtract step_size since scroll wheel has subtracted 1 already
            // else use the current value

            // round frequency to step size
            int temp_frequency = set_frequency.Value; // use a temp value so we don't have to worry about the band edges.
            temp_frequency = temp_frequency / (step_size + 1);
            temp_frequency = temp_frequency * (step_size + 1);
            set_frequency.Value = temp_frequency;

            // display the new frequency and send to Ozy  
            DisplayFrequency(set_frequency.Value);
            // save current value so we can compare with next value so we can determine tune direction
            previous_frequency_value = set_frequency.Value;

            //send to server, added by W3SZ

            byte[] textstrng = StrToByteArray("freq" + set_frequency.Value.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider
            }
        }

        
        public float ProcGain;
        public float VOXThreshold;

        public bool received_flag = false;

     

        public bool squelched = false;

        // process bandscope and filter squelch.
        private void Squelch()
        {
            /* 
             * 
             * When using the filter width squelch we need to compenstate for the fact that the bandwidth is wider than
             * that when using the bandscope width. The FFT bin width (Hz) for the bandscope is 
             * 
             *      bandwidth =  sampling rate / FFT size 
             *      
             * For the filter bandwidth we can just read the filter slider.
             * Hence the  noise power will be higher in the filter bandwidth by 
             * 
             *       ratio = filter bandwidth/(sampling rate/FFT size)
             *       
             * Since we are working in dB power levels we need to take 10log of this value and apply to the signal level
             * 
             */
                        
            // if squelch is not selected then just return
            if (!bandscopeSquelch && !filterSquelch)
            {
                Squelch_level.BackColor = SystemColors.Control;
                return;
            }

            int BandWidthCorrection;
            if (FreqSpan != 0)
            {
                BandWidthCorrection = Convert.ToInt32(10.0f * Math.Log10(BandwidthTrackBar.Value / (FreqSpan / 1024)));
            }
            else
            {
                BandWidthCorrection = Convert.ToInt32(10.0f * Math.Log10(BandwidthTrackBar.Value / (SampleRate / 1024)));
            }

            // Do Bandscope squelch
            if (bandscopeSquelch && (max_signal < Squelch_level.Value/10))
            {
                    squelched = true;
                    Squelch_level.BackColor = Color.Yellow; // change the slider background to show we have muted the audio 
            }

            // Do filter squelch - this uses the average SMeter value as its level
            else if (filterSquelch && (filter_max_signal < ((Squelch_level.Value / 10) + BandWidthCorrection)))
            {
                squelched = true;
                Squelch_level.BackColor = Color.Yellow; // change the slider background to show we have muted the audio 
            }
            else  // use the user volume setting 
            {
                squelched = false; 
                Squelch_level.BackColor = Color.Green; // change the slider background to show are above threshold
            }

            setVolumeSquelched();
        }

        public bool PreampOn = false;

        private void Preamp_CheckedChanged(object sender, EventArgs e)
        {
            PreampOn = Preamp.Checked;
            byte[] textstrng = StrToByteArray("pamp" + Preamp.Checked.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                pictureBox3.Invalidate();
                set_frequency.Focus(); // return focus to the frequency slider
            }
        }


        //w3sz method to capture key strokes

        public string oldfreq = "222.100 000";

        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {

            // setting suppressKeyPress to true does several things:
            // 1) it prevents the auto-display of the key
            // 2) sets e.Handled to true
            // this keeps the textbox from being corrupted by typed keys that are
            // not processed by this event handler, and makes sure that what is (eventually)
            // displayed is correct

            if (display_freqB.Focused)
            {
                //for VFO B, split tx freq
            bool display = false;

            // process key presses from the numeric keypad and keyboard
            switch (keyData)
            {
                case Keys.D0:
                case Keys.NumPad0: KeypadFrequency += "0"; keycount++; break;

                case Keys.D1:
                case Keys.NumPad1: KeypadFrequency += "1"; keycount++; break;

                case Keys.D2:
                case Keys.NumPad2: KeypadFrequency += "2"; keycount++; break;

                case Keys.D3:
                case Keys.NumPad3: KeypadFrequency += "3"; keycount++; break;

                case Keys.D4:
                case Keys.NumPad4: KeypadFrequency += "4"; keycount++; break;

                case Keys.D5:
                case Keys.NumPad5: KeypadFrequency += "5"; keycount++; break;

                case Keys.D6:
                case Keys.NumPad6: KeypadFrequency += "6"; keycount++; break;

                case Keys.D7:
                case Keys.NumPad7: KeypadFrequency += "7"; keycount++; break;

                case Keys.D8:
                case Keys.NumPad8: KeypadFrequency += "8"; keycount++; break;

                case Keys.D9:
                case Keys.NumPad9: KeypadFrequency += "9"; keycount++; break;
                case Keys.Back:
                    if (keycount > 0)  // remove the last character entered
                    {
                        KeypadFrequency = KeypadFrequency.Remove(KeypadFrequency.Length - 1);
                        --keycount;
                    }
                    break;
                case Keys.Enter:
                    if (keycount > 0)   // so we don't trigger on the main Enter Key 
                        display = true;
                    break;

                case Keys.Decimal:
                case Keys.OemPeriod:
                    {
                       KeypadFrequency += ".";
                       keycount++;
                    }
                    break;

                // if Up arrow increment frequency by step size
                case Keys.Up:
                        {
                            Properties.Settings.Default.split_tx_freq222 = Properties.Settings.Default.split_tx_freq222 + step_size + 1;
                            Properties.Settings.Default.Save();
                            DisplayFrequencyB(Properties.Settings.Default.split_tx_freq222);
                            KeypadFrequency = null;
                            keycount = 0;
                            set_frequency.Focus(); // return focus to the frequency slider
                            return true;
                        }

                // if Down arrow decrement frequency by step size
                case Keys.Down:
                        {
                            Properties.Settings.Default.split_tx_freq222 = Properties.Settings.Default.split_tx_freq222 - step_size - 1;
                            Properties.Settings.Default.Save();
                            DisplayFrequencyB(Properties.Settings.Default.split_tx_freq222);
                            KeypadFrequency = null;
                            keycount = 0;
                            set_frequency.Focus(); // return focus to the frequency slider
                            return true;
                                                    }

                case Keys.A:
                    stepSize.Text = "1Hz";
                    stepSize_SelectedIndexChanged(this, EventArgs.Empty);
                    return true;
                case Keys.B:
                    stepSize.Text = "10Hz";
                    stepSize_SelectedIndexChanged(this, EventArgs.Empty);
                    return true;
                case Keys.C:
                    stepSize.Text = "100Hz";
                    stepSize_SelectedIndexChanged(this, EventArgs.Empty);
                    return true;
                case Keys.D:
                    stepSize.Text = "1kHz";
                    stepSize_SelectedIndexChanged(this, EventArgs.Empty);
                    return true;
                case Keys.E:
                    Mode.Text = "FM";
                    Mode_SelectedIndexChanged(this, EventArgs.Empty);
                    return true;
                case Keys.F:
                    Mode.Text = "USB";
                    Mode_SelectedIndexChanged(this, EventArgs.Empty);
                    return true;
                case Keys.G:
                    Mode.Text = "LSB";
                    Mode_SelectedIndexChanged(this, EventArgs.Empty);
                    return true;
                case Keys.H:
                    Mode.Text = "CWU";
                    Mode_SelectedIndexChanged(this, EventArgs.Empty);
                    return true;
                case Keys.I:
                    Mode.Text = "CWL";
                    Mode_SelectedIndexChanged(this, EventArgs.Empty);
                    return true;
                // if not a valid key then exit
                default: display = false; return true;
            }

            double temp = 0.0d;
            long setfrequency;
            if (display)  // user has pressed enter key 
            {
                try  // data format may be incorrect so check
                {
                    // must use the invariant culture here, so that the '.' is properly
                    // interpreted as a decimal separator!
                    temp = Convert.ToDouble(KeypadFrequency, nfi); // convert to a float 
                }

                catch // format error so tidy up and return
                    {
                        display_freqB.Text = oldfreq;    // display the previous frequency
                        set_frequency.Focus(); // return focus to the frequency slider
                        KeypadFrequency = null;
                        keycount = 0;
                        return true;
                }
                double temp2 = temp * 1000000.0d;  // Multiply by 10e6 to give Hz
                setfrequency = (long)temp2 - LO - LOoffset; // convert to an integer
                // check frequency is valid
                if ((keycount > 0) && (keycount < 12) && (setfrequency < 31000000) && (setfrequency > 27000000))
                    {
                    // display the new frequency and send to server
                    DisplayFrequencyB(setfrequency);
                    KeypadFrequency = null;
                    keycount = 0;
                    set_frequency.Focus(); // return focus to the frequency slider
                    return true;
                }
                else  // error, abort
                    {
                        display_freqB.Text = oldfreq;   // display the previous frequency
                        KeypadFrequency = null;
                        keycount = 0;
                        set_frequency.Focus(); // return focus to the frequency slider
                        return true;
                }
            }
            else
            {
                try
                {
                        // display the frequency as it is entered but only the text entered on the keypad 
                        //    display_freqB.Text = Convert.ToString(Double.Parse(KeypadFrequency));
                        display_freqB.Text = KeypadFrequency;

                    }
                    catch
                {
                }
            }

        }  ///end VFO B

            else   ///start VFO A

            { 
            bool display = false;

            // process key presses from the numeric keypad and keyboard
            switch (keyData)
            {
                case Keys.D0:
                case Keys.NumPad0: KeypadFrequency += "0"; keycount++; break;

                case Keys.D1:
                case Keys.NumPad1: KeypadFrequency += "1"; keycount++; break;

                case Keys.D2:
                case Keys.NumPad2: KeypadFrequency += "2"; keycount++; break;

                case Keys.D3:
                case Keys.NumPad3: KeypadFrequency += "3"; keycount++; break;

                case Keys.D4:
                case Keys.NumPad4: KeypadFrequency += "4"; keycount++; break;

                case Keys.D5:
                case Keys.NumPad5: KeypadFrequency += "5"; keycount++; break;

                case Keys.D6:
                case Keys.NumPad6: KeypadFrequency += "6"; keycount++; break;

                case Keys.D7:
                case Keys.NumPad7: KeypadFrequency += "7"; keycount++; break;

                case Keys.D8:
                case Keys.NumPad8: KeypadFrequency += "8"; keycount++; break;

                case Keys.D9:
                case Keys.NumPad9: KeypadFrequency += "9"; keycount++; break;
                case Keys.Back:
                    if (keycount > 0)  // remove the last character entered
                        {
                        KeypadFrequency = KeypadFrequency.Remove(KeypadFrequency.Length - 1);
                        --keycount;
                        }
                    break;
                case Keys.Enter:
                    if (keycount > 0)   // so we don't trigger on the main Enter Key 
                        display = true;
                    break;

                case Keys.Decimal:
                case Keys.OemPeriod:
                    {
                        KeypadFrequency += ".";
                        keycount++;
                    }
                    break;

                // if Up arrow increment frequency by step size
                case Keys.Up: KeypadFrequency = set_frequency.Value++.ToString(); display = true; break;

                // if Down arrow decrement frequency by step size
                case Keys.Down: KeypadFrequency = set_frequency.Value--.ToString(); display = true; break;

                case Keys.A:
                    stepSize.Text = "1Hz";
                    stepSize_SelectedIndexChanged(this, EventArgs.Empty);
                    return true;
                case Keys.B:
                    stepSize.Text = "10Hz";
                    stepSize_SelectedIndexChanged(this, EventArgs.Empty);
                    return true;
                case Keys.C:
                    stepSize.Text = "100Hz";
                    stepSize_SelectedIndexChanged(this, EventArgs.Empty);
                    return true;
                case Keys.D:
                    stepSize.Text = "1kHz";
                    stepSize_SelectedIndexChanged(this, EventArgs.Empty);
                    return true;
                case Keys.E:
                    Mode.Text = "FM";
                    Mode_SelectedIndexChanged(this, EventArgs.Empty);
                    return true;
                case Keys.F:
                    Mode.Text = "USB";
                    Mode_SelectedIndexChanged(this, EventArgs.Empty);
                    return true;
                case Keys.G:
                    Mode.Text = "LSB";
                    Mode_SelectedIndexChanged(this, EventArgs.Empty);
                    return true;
                case Keys.H:
                    Mode.Text = "CWU";
                    Mode_SelectedIndexChanged(this, EventArgs.Empty);
                    return true;
                case Keys.I:
                    Mode.Text = "CWL";
                    Mode_SelectedIndexChanged(this, EventArgs.Empty);
                    return true;
                // if not a valid key then exit
                default:
                        {
                            display = false;
                            return true;
                        }
            }

            double temp = 0.0d;
            long setfrequency;
            if (display)  // user has pressed enter key 
            {
                try  // data format may be incorrect so check
                {
                    // must use the invariant culture here, so that the '.' is properly
                    // interpreted as a decimal separator!
                    temp = Convert.ToDouble(KeypadFrequency, nfi); // convert to a float 
                }

                catch // format error so tidy up and return
                {
                    Frequency_change();     // display the previous frequency
                    set_frequency.Focus(); // return focus to the frequency slider
                    KeypadFrequency = null;
                    keycount = 0;
                    return true;
                }
                double temp2 = temp * 1000000.0d;  // Multiply by 10e6 to give Hz
                setfrequency = (long)temp2 - LO - LOoffset; // convert to an integer
                // check frequency is valid
                if ((keycount > 0) && (keycount < 12) && (setfrequency < 31000000) && (setfrequency > 27000000))
                    {
                    Console.WriteLine(setfrequency);
                    set_frequency.Value = Convert.ToInt32(setfrequency);
                    // display the new frequency and send to Ozy
                    DisplayFrequency(setfrequency);
                    KeypadFrequency = null;
                    keycount = 0;
                    set_frequency.Focus(); // return focus to the frequency slider

                    return true;
                }
                else  // error, abort
                {
                    Frequency_change();     // display the previous frequency
                    set_frequency.Focus(); // return focus to the frequency slider
                    KeypadFrequency = null;
                    keycount = 0;
                    return true;
                }
            }
            else
            {
                try
                {
                    // display the frequency as it is entered but only the text entered on the keypad 
                    display_freq.Text = KeypadFrequency;

                }
                catch
                {
                }
            }
        } ///end VFOA

            return true; // base.ProcessCmdKey(ref msg, keyData);
        }


        public void DisplayFrequency(long setfrequency)
        {
            byte[] textstrng = StrToByteArray("freq" + set_frequency.Value.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider
            }
            xvtr_frequency = setfrequency + LO + LOoffset;
            string temp_freq =Convert.ToString(xvtr_frequency);
      
            // strip off the last 6 digits, add a decimal point, then add them back 
            temp_freq = temp_freq.Remove(temp_freq.Length - 6) + '.' + temp_freq.Substring(temp_freq.Length - 6, 6);
            display_freq.Text = temp_freq.Remove(temp_freq.Length - 3) + ' ' + temp_freq.Substring(temp_freq.Length - 3, 3);
        }

        public void DisplayFrequencyB(long setfrequency)
        {

            byte[] textstrng = StrToByteArray("freB" + setfrequency.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider
            }

            Properties.Settings.Default.split_tx_freq222 = setfrequency;
            Properties.Settings.Default.Save();

            xvtr_frequencyB = setfrequency + LO + LOoffset;
            split_tx_freq = Convert.ToString(xvtr_frequencyB);
            // strip off the last 6 digits, add a decimal point then add them back 
            string split_tx_freq2 = split_tx_freq.Remove(split_tx_freq.Length - 6) + '.' + split_tx_freq.Substring(split_tx_freq.Length - 6, 6);
            display_freqB.Text = split_tx_freq2.Remove(split_tx_freq2.Length - 3) + ' ' + split_tx_freq2.Substring(split_tx_freq2.Length - 3, 3);
            oldfreq = display_freqB.Text;
        }


        private void pictureBox1_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;

                DrawSpectrumGrid(g);
                RefreshSpectrumScope(g);
                RefreshWaterFall(g);  
        }
      
        private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {              
            // check if we are adjacent to the right filter location, if so change the mouse cursor to <-> and 
            // disable mouse drag tuning of the frequency and filter shift
            if (Control.MouseButtons == MouseButtons.Left && MousePositionX > FilterRight - 5 && MousePositionX < FilterRight)
            {
                pictureBox1.Cursor = Cursors.SizeWE; // change cursor to <->
                FrequencyDrag = false;   // turn off drag tuning of frequency and filter shift 
                BandwidthShift = false;
                HighFilter = true;      // allow drag tuning of high filter frequency
                LowFilter = false;
            }
            // check if we are adjacent to the left filter location, if so change the mouse cursor to <-> and 
            // disable mouse drag tuning of the frequency and filter shift
            else if (Control.MouseButtons == MouseButtons.Left && MousePositionX > FilterLeft && MousePositionX < FilterLeft + 5)
            {
                pictureBox1.Cursor = Cursors.SizeWE; // change cursor to <->
                FrequencyDrag = false;      // turn off drag tuning of frequency and filter shift 
                BandwidthShift = false;
                HighFilter = false;
                LowFilter = true;           // allow drag tuning of low filter frequency
            }

            // if the mouse position is to the left or right of the filter location then change the mouse cursor to a hand
            // and enable frequency drag. If we have right clicked then ShowCross will be true in which case set the frequency  
            // to the current mouse position.
            else if (Control.MouseButtons == MouseButtons.Left && (MousePositionX < FilterLeft || MousePositionX > FilterRight))
            {
                pictureBox1.Cursor = Cursors.Hand; // change cursor to a hand

                FrequencyDrag = true;  // we are not inside the filter bandwidth so enable drag tuning

                // if the cross is shown then set frequency to the X location of the mouse
                if (ShowCross)
                {            // calculate the number of Hz each pixel represents, will be  sample rate/screen bandscope width
                    Double HzPerPixel;
                    if (FreqSpan != 0)
                    {
                        HzPerPixel = FreqSpan / pictureBox1.Width; // how many pixels per 100Hz across the screen 
                    }
                    else
                    {
                        HzPerPixel = SampleRate / pictureBox1.Width;
                    }


                    // calculate the  how many Hz the X mouse location represents from the left edge of the screen
                    Double offset = MousePositionX * HzPerPixel;
                    int left_edge_frequency;
                    // the frequency at the left edge of the screen will be the tuned frequency - sample rate/2
                    if (FreqSpan != 0)
                    {
                        left_edge_frequency = set_frequency.Value - Convert.ToInt32(FreqSpan / 2);
                    }
                    else
                    {
                        left_edge_frequency = set_frequency.Value - SampleRate / 2;
                    }
                    // add the offset to the left edge frequency
                    // do so in a way that does NOT generate an exception when going too low in frequency
                    if (left_edge_frequency + offset <= set_frequency.Minimum)
                    {
                        set_frequency.Value = set_frequency.Minimum;
                    }
                    else if (left_edge_frequency + offset >= set_frequency.Maximum)
                    {
                        set_frequency.Value = set_frequency.Maximum;
                    }
                    else
                    {
                        if (Mode.Text == "CWL")  // TODO: Hack so that click tune on CWL mode works - need to fix
                            set_frequency.Value = Convert.ToInt32(left_edge_frequency + offset + Globals.CWPitch);
                        else if (Mode.Text == "CWU")  // TODO: Hack 1000 so that click tune on CWU mode works - need to fix
                            set_frequency.Value = Convert.ToInt32(left_edge_frequency + offset - Globals.CWPitch);
                        else
                            set_frequency.Value = Convert.ToInt32(left_edge_frequency + offset);
                    }
                    // display the new frequency and send to Ozy
                    DisplayFrequency(set_frequency.Value);  //transverter here too
                    set_frequency.Focus(); // return focus to the frequency slider

                    //send to server

                    byte[] textstrng = StrToByteArray("freq" + set_frequency.Value.ToString()); //w3sz  convert to byte array

                    if (Properties.Settings.Default.Checked222)
                    {
                        sendCommandAsync(textstrng, w3szendpoint1, port1);
                        set_frequency.Focus(); // return focus to the frequency slider
                    }
                }
            }
            // if the right mouse button is down then show large cross 
            else if (Control.MouseButtons == MouseButtons.Right)  // change the cursor to to a large cross
            {
                pictureBox1.Cursor = Cursors.Cross;         // change cursor to a small cross
                // set the ShowCross flag, this is read in the DrawGrid() Method
                ShowCross = !ShowCross;                     // toggle the cross each right click
                FrequencyDrag = true;
            }

            else // we are inside the filter bandwidth so disable frequency drag tuning
            {
                FrequencyDrag = false;
                pictureBox1.Cursor = Cursors.NoMoveHoriz;
            }
        }
        
        private void pictureBox1_MouseEnter(object sender, EventArgs e)
        {
            pictureBox1.Cursor = Cursors.Cross;
        }
        
        private void pictureBox1_MouseLeave(object sender, EventArgs e)
        {
            pictureBox1.Cursor = Cursors.Default;
        }

        
        int mouse_delta_Y;

        private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
        {
            // get the current cursor shape so we can restore it upon leaving 
            Cursor CurrentCursor = pictureBox1.Cursor;

            MousePositionX = e.X;   // get the mouse X and Y coordintes with respect to the bandscope
            MousePositionY = e.Y;   // these are used by the right mouse click over bandscope             
            Point MouseX = new Point();  // the mouse coordinates have a type Point
            MouseX = Control.MousePosition;  // get current mouse postion (X,Y) with respect to the screen
                                             // so we can drag tune outside the width of the bandscope area 
            delta = MouseOld.X - MouseX.X;  // get the difference between the last and current Mouse X coordinate
            int abs_delta = Math.Abs(delta);
            mouse_delta_Y = MouseOld.Y - MouseX.Y; // get the diffetence between the last and current Mouse Y coordinate
            int abs_mouse_delta_Y = Math.Abs(mouse_delta_Y);

            if (Control.MouseButtons == MouseButtons.Left && FrequencyDrag) // do this if the left mouse button is down
            {
                // if mouse has moved left then decrease frequency but first 
                // we need to check if we are too close to the band edges to move 
                if (delta < 0)
                {
                    if (FreqSpan != 0)
                    {
                        if (set_frequency.Value > (set_frequency.Minimum + Convert.ToInt32(abs_delta * (FreqSpan / pictureBox1.Width))))
                            set_frequency.Value -= Convert.ToInt32(abs_delta * (FreqSpan / pictureBox1.Width));
                    }
                    else
                    {
                        if (set_frequency.Value > (set_frequency.Minimum + abs_delta * SampleRate/ pictureBox1.Width))
                            set_frequency.Value -= abs_delta *SampleRate / pictureBox1.Width;
              
                    }
                }
                // if mouse has moved right then decrease frequency but first
                // we need to check if we are too close to the band edges to move  
                else if (delta > 0)
                {
                    if (FreqSpan != 0)
                    {
                        if (set_frequency.Value < (set_frequency.Maximum - Convert.ToInt32(abs_delta * ((FreqSpan) / pictureBox1.Width))))
                            set_frequency.Value += Convert.ToInt32(abs_delta * ((FreqSpan) / pictureBox1.Width));
                    }
                    else
                        if (set_frequency.Value < (set_frequency.Maximum - abs_delta * (SampleRate / pictureBox1.Width)))
                            set_frequency.Value += abs_delta * (SampleRate / pictureBox1.Width);
                }


                DisplayFrequency(set_frequency.Value);  //transverter here too

                set_frequency.Focus(); // return focus to the frequency slider

                //send to server

                byte[] textstrng = StrToByteArray("freq" + set_frequency.Value.ToString()); //w3sz  convert to byte array


                if (Properties.Settings.Default.Checked222)
                {
                    sendCommandAsync(textstrng, w3szendpoint1, port1);
                    set_frequency.Focus(); // return focus to the frequency slider

                }
            }

            // Allow user to alter  filter  high and low frequencies using mouse.
            // If the mouse is in the region of the left edge of the filter allow it to be drag tuned
            // Placing the mouse in this region will alter the cursor, if the left mouse button is
            // down then the filter can be altered by dragging the mouse left or right.
            // If the user has pressed the left mouse button whilst in this region then LowFilter will be true

            else if (MousePositionX > FilterLeft && MousePositionX < FilterLeft + 5 || LowFilter)
            {
                pictureBox1.Cursor = Cursors.SizeWE;            // change cursor to <->
                if (Control.MouseButtons == MouseButtons.Left)
                {
                    BandwidthShift = false; // turn off bandwith shifting with mouse
                    if (delta > 0) // then we are draging to the left  and delta is positive
                    {
                        if (Mode.Text == "LSB" || Mode.Text == "CWL")
                        {
                            if (FilterFrequencyHigh > -9999.0f)
                                FilterFrequencyHigh -= delta * 100;
                        }
                        else
                        {
                            if (FilterFrequencyLow > -9999.0f)
                                FilterFrequencyLow -= delta * 100;
                        }
                    }
                    if (delta < 0) // then we are draging to the right  and delta is negative
                    {
                        if (Mode.Text == "LSB" || Mode.Text == "CWL")
                        {
                            if (FilterFrequencyHigh < 9999.0f)
                                FilterFrequencyHigh -= delta * 100;
                        }
                        else
                        {
                            if (FilterFrequencyLow < 9999.0f)
                                FilterFrequencyLow -= delta * 100;
                        }
                    }
                }
            }

            // If the mouse is in the region of the right edge of the filter allow it to be drag tuned
            // Placing the mouse in this region will alter the cursor, if the left mouse button is
            // down then the filter can be altered by draging the mouse left or right.
            // If the user has pressed the left mouse button whilst in this region then HighFilter will be true
            else if (MousePositionX > FilterRight - 5 && MousePositionX < FilterRight || HighFilter)
            {
                pictureBox1.Cursor = Cursors.SizeWE;        // change cursor to <->
                if (Control.MouseButtons == MouseButtons.Left)
                {
                    BandwidthShift = false; // turn off bandwith shifting with mouse
                    if (delta > 0) // then we are draging to the left and delta is positive
                    {
                        if (Mode.Text == "LSB" || Mode.Text == "CWL") // need to invert if so
                        {
                            if (FilterFrequencyLow > -9999.0f)
                                FilterFrequencyLow -= delta * 100;
                        }
                        else
                        {
                            if (FilterFrequencyHigh > -9999.0f)
                                FilterFrequencyHigh -= delta * 100;
                        }

                    }
                    if (delta < 0) // then we are dragging to the right and delta is negative
                    {
                        if (Mode.Text == "LSB" || Mode.Text == "CWL") // need to invert if so
                        {
                            if (FilterFrequencyLow < 9999.0f)
                                FilterFrequencyLow -= delta * 100;
                        }
                        else
                        {
                            if (FilterFrequencyHigh < 9999.0f)
                                FilterFrequencyHigh -= delta * 100;
                        }
                    }

                }
            }

            // If the mouse is over the filter bandwith  change the cursor. If the left mouse button is also down then 
            // drag tune the filter frequency i.e passband tuning
            else if (MousePositionX > FilterLeft + 5 && MousePositionX < FilterRight - 5 || !FrequencyDrag && BandwidthShift)
            {
                pictureBox1.Cursor = Cursors.NoMoveHoriz;

                if (Control.MouseButtons == MouseButtons.Left && !FrequencyDrag) // and if the left mouse is down move filter
                {
                    // determine how wide the current filter is
                    int FilterWidth = Math.Abs(Convert.ToInt32(FilterFrequencyLow - FilterFrequencyHigh));
                    {
                        if (delta < 0)  // then we are draging to the right and delta is negative
                        {
                            if (Mode.Text == "LSB" || Mode.Text == "CWL")
                            {
                                if (FilterFrequencyLow < 9999.0f)  // only drag to the maximum bandwidth
                                {
                                    FilterFrequencyLow -= delta * 100;
                                    FilterFrequencyHigh = FilterFrequencyLow - FilterWidth;
                                }
                            }
                            else
                            {
                                if (FilterFrequencyHigh < 9999.0f)  // only drag to the maximum bandwidth
                                {
                                    FilterFrequencyLow -= delta * 100;
                                    FilterFrequencyHigh = FilterFrequencyLow + FilterWidth; // all other modes
                                }
                            }
                        }
                        if (delta > 0)  // then we are draging to the left and delta is positive
                        {

                            if (Mode.Text == "LSB" || Mode.Text == "CWL")
                            {
                                if (FilterFrequencyHigh > -9999.0f) // only drag to the maximum bandwidth
                                {
                                    FilterFrequencyHigh -= delta * 100;
                                    FilterFrequencyLow = FilterFrequencyHigh + FilterWidth;
                                }
                            }
                            else
                            {
                                if (FilterFrequencyLow > -9999.0f) // only drag to the maximum bandwidth
                                {
                                    FilterFrequencyHigh -= delta * 100;
                                    FilterFrequencyLow = FilterFrequencyHigh - FilterWidth;
                                }
                            }
                        }
                    }
                }
            }
            else
            {
                pictureBox1.Cursor = Cursors.Cross;  // restore cursor
            }

            MouseOld = MouseX; // save the last mouse X location for next time the mouse moves
            UpdateGraphs(); //w3sz added this so yellow cursor's update rate is not dependent on FFT time
        }

        private void pictureBox1_MouseUp(object sender, MouseEventArgs e)
        {
            pictureBox1.Cursor = Cursors.Cross;
            FrequencyDrag = true;
            BandwidthShift = true;
            HighFilter = false;
            LowFilter = false;
        }

             // show the squelch level the user has set
        public void Squelch_level_Scroll(object sender, EventArgs e)
        {
            Squelch_setting.Text = (Squelch_level.Value/10).ToString();

            byte[] textstrng = StrToByteArray("sque" + Squelch_setting.Text); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider
            }

        }

             
        private bool squelchOn = false;

        private bool bandscopeSquelch = false;

        private void Bandscope_squelch_CheckedChanged(object sender, EventArgs e)
        {
            bandscopeSquelch = Bandscope_squelch.Checked;

            if (bandscopeSquelch)
            {
                if (filterSquelch)
                    Filter_squelch.Checked = false;

                squelchOn = true;
            }
            else
            {
                if (!filterSquelch)
                {
                    squelchOn = false;
                    setVolumeSquelched();
                }
            }


            byte[] textstrng = StrToByteArray("sqOn" + bandscopeSquelch.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider
            }
            
        }
        
        private bool filterSquelch = false;
        
        private void Filter_squelch_CheckedChanged(object sender, EventArgs e)
        {
            filterSquelch = Filter_squelch.Checked;

            if (filterSquelch)
            {
                if (bandscopeSquelch)
                    Bandscope_squelch.Checked = false;

                squelchOn = true;
            }
            else
            {
                if (!bandscopeSquelch)
                {
                    squelchOn = false;
                    setVolumeSquelched();
                }
            }

            byte[] textstrng = StrToByteArray("sqfi" + filterSquelch.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider
            }
        }
        
        // set the drive level to Penelope 
        public void DriveLevel_Scroll(object sender, EventArgs e)
        {
            Drive = DriveLevel.Value.ToString();
            Drivetxt.Text = Drive;
            // apply square law to drive level control
            DriveGain = (float)Math.Pow(DriveLevel.Value, 2) / 10000;  // DriveGain is float from 0 to 1.0

            byte[] textstrng = StrToByteArray("Driv" + Drive); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider
            }
        }

        
        //especially for MethodInvoker to use from another thread.
        public void ToggleOnOffButton()
        {
            OnOffButton_Click(this, EventArgs.Empty);
        }

        string codectypevoice = "Voip";
        string codectypedata = "Audio";
        public void OnOffButton_Click(object sender, EventArgs e)
        {
            if (OnOffButton.BackColor == SystemColors.Control)
            {
                OnOffButton.BackColor = Color.Green;
                OnOffButton.Text = "ON";

                // make sure any changes made while not running are set to the new ourDevice instance
                SetTXFilterBandwidth();

                KK_on = true;
                set_frequency.Focus(); // set focus to the frequency slider

                byte[] modetextstrng = StrToByteArray("mode" + ModeText); //w3sz  convert to byte array
                byte[] leftvoltextstrng = StrToByteArray("rvol" + VolumeLeft.ToString()); //w3sz  convert to byte array
                byte[] rightvoltextstrng = StrToByteArray("lvol" + VolumeRight.ToString()); //w3sz  convert to byte array
                byte[] AGCMaxGaintextstrng = StrToByteArray("AGCM" + AGCTrackBar.Value.ToString()); //w3sz  convert to byte array
                byte[] Drivetextstrng = StrToByteArray("Driv" + Drive); //w3sz  convert to byte array
                byte[] frequencytextstrng = StrToByteArray("freq" + set_frequency.Value.ToString()); //w3sz  convert to byte array
                byte[] squelchtextstrng = StrToByteArray("sque" + Squelch_setting.Text); //w3sz  convert to byte array
                byte[] squelchOntextstrng = StrToByteArray("sqOn" + bandscopeSquelch.ToString()); //w3sz  convert to byte array
                byte[] filtersquelchOntextstrng = StrToByteArray("sqfi" + filterSquelch.ToString()); //w3sz  convert to byte array
                byte[] stepsizetextstrng = StrToByteArray("step" + stepSize.Text); //w3sz  convert to byte array
                byte[] AGCSpeedtextstrng = StrToByteArray("AGCS" + AGCSpeed.Text); //w3sz  convert to byte array
                byte[] ANFCheckedtextstrng = StrToByteArray("NN10" + ANF.Checked.ToString()); //w3sz  convert to byte array
                byte[] NRCheckedtextstrng = StrToByteArray("NR11" + NR.Checked.ToString()); //w3sz  convert to byte array
                byte[] NB1Checkedtextstrng = StrToByteArray("NB10" + NB1.Checked.ToString()); //w3sz  convert to byte array
                byte[] NB2Checkedtextstrng = StrToByteArray("NB20" + NB2.Checked.ToString()); //w3sz  convert to byte array
                byte[] PreampCheckedtextstrng = StrToByteArray("pamp" + Preamp.Checked.ToString()); //w3sz  convert to byte array
                byte[] chkClippertextstrng = StrToByteArray("clip" + chkClipper.Checked.ToString()); //w3sz  convert to byte array
                byte[] chkNoiseGatetextstrng = StrToByteArray("NGck" + chkNoiseGate.Checked.ToString()); //w3sz  convert to byte array
                byte[] ProcessorGaintextstrng = StrToByteArray("PrGV" + ProcessorGain.Value.ToString()); //w3sz  convert to byte array
                byte[] MicGaintextstrng = StrToByteArray("McGV" + MicrophoneGain.Value.ToString()); //w3sz  convert to byte array
                byte[] NGLeveltextstrng = StrToByteArray("NGLV" + NoiseGateLevel.Value.ToString()); //w3sz  convert to byte array
                byte[] labelFilterWidthtextstrng = StrToByteArray("FiWi" + labelFilterWidth.Text); //w3sz  convert to byte array
                byte[] SampleRatetextstrng = StrToByteArray("SaRt" + SampleRate.ToString());  //w3sz
                byte[] FFTSizetextstrng = StrToByteArray("FFTS" + FFTSize.ToString());  //w3sz
                byte[] Zoom100textstrng = StrToByteArray("z100" + Zoom100.Checked.ToString()); //w3sz  convert to byte array
                byte[] Zoom75textstrng = StrToByteArray("z075" + Zoom75.Checked.ToString()); //w3sz  convert to byte array
                byte[] Zoom50textstrng = StrToByteArray("z050" + Zoom50.Checked.ToString()); //w3sz  convert to byte array
                byte[] Zoom25textstrng = StrToByteArray("z025" + Zoom25.Checked.ToString()); //w3sz  convert to byte array
                byte[] ZoomTrackBartextstrng = StrToByteArray("ztra" + Zoom_Track_Bar.Value.ToString()); //w3sz  convert to byte array
                byte[] gaintextstrng = StrToByteArray("ga22" + MicroMHz.Gain222MHz.ToString()); //w3sz  convert to byte array
                byte[] CWPitchtextstrng = StrToByteArray("CWPI" + Globals.CWPitch.ToString()); //w3sz  convert to byte array
                byte[] frequencyBstrng = StrToByteArray("freB" + Properties.Settings.Default.split_tx_freq222);
                byte[] splitstrng = StrToByteArray("splt" + splitBox.Checked.ToString());
                if(Properties.Settings.Default.voiceCodecIsVoip)
                {
                    codectypevoice = "Voip";
                }
                else
                {
                    codectypevoice = "Audio";
                }
                if (Properties.Settings.Default.dataCodecIsVoip)
                {
                    codectypedata = "Voip";
                }
                else
                {
                    codectypedata = "Audio";
                }
                byte[] DataCodectextstrng = StrToByteArray("DaCo" + codectypevoice); //w3sz  convert to byte array
                byte[] DataBRtextstrng = StrToByteArray("DaBR" + Properties.Settings.Default.dataBitrate); //w3sz  convert to byte array
                byte[] VoiceCodectextstrng = StrToByteArray("VoCo" + codectypedata); //w3sz  convert to byte array
                byte[] VoiceBRtextstrng = StrToByteArray("VoBR" + Properties.Settings.Default.voiceBitrate); //w3sz  convert to byte array
                byte[] DataBWtextstrng = StrToByteArray("DaBW" + Properties.Settings.Default.dataBandwidth); //w3sz  convert to byte array
                byte[] VoiceBWtextstrng = StrToByteArray("VoBW" + Properties.Settings.Default.voiceBandwidth); //w3sz  convert to byte array
                byte[] opusTxComptextstrng = StrToByteArray("TxOp" + Properties.Settings.Default.opusTxComp);
                byte[] opusComptextstrng = StrToByteArray("Opus" + Properties.Settings.Default.opusComp);
                byte[] mainMictextstrng = StrToByteArray("MMIC" + Properties.Settings.Default.mainMicOn);
                byte[] auxMictextstrng = StrToByteArray("AMIC" + Properties.Settings.Default.auxMicOn);
                if (Properties.Settings.Default.Checked222)
                {

                   sendsetupCommandAsync(
                   modetextstrng, leftvoltextstrng, rightvoltextstrng, AGCMaxGaintextstrng,
                   Drivetextstrng, frequencytextstrng, squelchtextstrng, squelchOntextstrng,
                   filtersquelchOntextstrng, stepsizetextstrng, AGCSpeedtextstrng,
                   ANFCheckedtextstrng, NRCheckedtextstrng, NB1Checkedtextstrng,
                   NB2Checkedtextstrng, PreampCheckedtextstrng, chkClippertextstrng, chkNoiseGatetextstrng,
                   ProcessorGaintextstrng, MicGaintextstrng, NGLeveltextstrng, labelFilterWidthtextstrng,
                   SampleRatetextstrng, Zoom100textstrng, Zoom75textstrng, Zoom50textstrng,
                   Zoom25textstrng, ZoomTrackBartextstrng, FFTSizetextstrng, gaintextstrng, CWPitchtextstrng, 
                   frequencyBstrng, splitstrng, DataCodectextstrng, DataBRtextstrng,VoiceCodectextstrng, VoiceBRtextstrng,
                   DataBWtextstrng, VoiceBWtextstrng, opusTxComptextstrng, opusComptextstrng,  mainMictextstrng, auxMictextstrng,
                   w3szendpoint1, port1);
                }

            }
            else
            {
                OnOffButton.BackColor = SystemColors.Control;
                OnOffButton.Text = "OFF";                                           
                PTT = false;                                // force PTT off
                MOX_set = false;                            // force MOX off
                previous_OnlyTxOnPTT = OnlyTxOnPTT;         // save this status so we can restore it
                OnlyTxOnPTT = true;                         // force always PTT off 
                TUN.BackColor = SystemColors.Control;
                TUN_set = false;                            // force Tune off
                MOX.BackColor = SystemColors.Control;                           
                Thread.Sleep(100);                          // Delay so the PTT off is sent to Ozy
                OnlyTxOnPTT = previous_OnlyTxOnPTT;         // restore the previous status 
                KK_on = false;                              // set this last so PTT off gets sent
                set_frequency.Focus(); // set focus to the frequency slider
            }            
        }

        
        public bool ProcessorOn;
        private void chkClipper_CheckedChanged(object sender, EventArgs e)
        {
            if (chkClipper.Checked)
            {
                ProcessorOn = true;
            }
            else  // disable the controls
            {
                ProcessorOn = false;
                ProcessorGain.Enabled = false;
            }
            // renew the control value
            ProcessorGain.Enabled = true;
            ProcGain = ProcessorGain.Value / 10.0f;
            // display the Processor Gain in dB
            ProcGaindB.Text = (20 * Math.Log10(ProcGain)).ToString();
            ProcessorGainChange();

            byte[] textstrng = StrToByteArray("clip" + chkClipper.Checked.ToString()); //w3sz  convert to byte array


            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider
            }
        }

        public bool NoiseGateDelay;
        public bool NoiseGateSwitch;
        
        public float MicGain;

        private void MicrophoneGain_Scroll(object sender, EventArgs e)
        {
            // apply square law to gain control and allow max 20dB of gain 
            MicGain = (float) Math.Pow(MicrophoneGain.Value, 2)/1000.00f;

            byte[] textstrng = StrToByteArray("McGV" + MicrophoneGain.Value.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider

            }

        }

        public bool NoiseGate;

        private void chkNoiseGate_CheckedChanged(object sender, EventArgs e)
        {
            if (chkNoiseGate.Checked)
            {
                NoiseGate = true;
            }
            else
            {
                NoiseGate = false;
            }

            byte[] textstrng = StrToByteArray("NGck" + chkNoiseGate.Checked.ToString()); //w3sz  convert to byte array


            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider

            }
        }

        public float NoiseThreshold;

        private void NoiseGateLevel_Scroll(object sender, EventArgs e)
        {
            NoiseThreshold = 1.0f - (float)Math.Pow(NoiseGateLevel.Value, 2) / 10000.0f;

            byte[] textstrng = StrToByteArray("NGLV" + NoiseGateLevel.Value.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider

            }
        }

        private void ProcessorGainChange()
        {
            // get the Processor gain
            ProcGain = ProcessorGain.Value / 10.0f;
            // display the Processor Gain in dB
            ProcGaindB.Text = (20 * Math.Log10(ProcGain)).ToString();
        }

        public void ProcessorGain_Scroll(object sender, EventArgs e)
        {
            ProcessorGainChange();

            byte[] textstrng = StrToByteArray("PrGV" + ProcessorGain.Value.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider
            }

        }

        private void ProcessorGain_ValueChanged(object sender, EventArgs e)
        {
            ProcessorGainChange();
        }



        private void _222MHz_pictureBox1_MouseClick(object sender, MouseEventArgs e)
        {
            if (Properties.Settings.Default.Checked222)
            {
                if (e.Button == MouseButtons.Left)
                {
                    if ((Globals.main222 == false) & (Globals.aux222 == false))
                    {
                        Globals.main222 = true;
                        Globals.aux222 = false;
                        form1.main222But.Checked = true;
                        DriveLevel_Scroll(this, EventArgs.Empty);
                        ProcessorGain_Scroll(this, EventArgs.Empty);
                        Autoset_frequency_Scroll_1(this, EventArgs.Empty);
                        Squelch_level_Scroll(this, EventArgs.Empty);
                        UpdateGraphs();  //w3sz
                    }
                }
                else if (e.Button == MouseButtons.Right)
                {
                    if ((Globals.main222 == false) & (Globals.aux222 == false))
                    {
                        Globals.aux222 = true;
                        Globals.main222 = false;
                        form1.aux222But.Checked = true;
                        DriveLevel_Scroll(this, EventArgs.Empty);
                        ProcessorGain_Scroll(this, EventArgs.Empty);
                        Autoset_frequency_Scroll_1(this, EventArgs.Empty);
                        Squelch_level_Scroll(this, EventArgs.Empty);
                        UpdateGraphs();  //w3sz
                    }
                }
            }
        }

         private void _222MHz_pictureBox1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            if (Properties.Settings.Default.Checked222)
            {
                if (Control.ModifierKeys == Keys.Control)
                {
                    if ((Globals.main222 == true) || (Globals.aux222 == true))
                    {
                        Globals.aux222 = false;
                        Globals.main222 = false;

                        this.Size = Globals.formsmallsize;
                        this.Location = Globals.form222smallloc;
                        pictureBox1.Size = Globals.boxsmallsize;
                        pictureBox1.Location = Globals.box1smallloc;
                        this.Refresh();
                        form1.main222But.Checked = false;
                        form1.aux222But.Checked = false;

                        UpdateGraphs();  //w3sz
                    }
                }
            }
        }

        private void Form_Closing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
        }

       
        
        public OpBand CurrentBand;

        
        private void setupToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // only allow user to open form if not already open
            if (!SetupForm222Valid())
            {
                Setup_form222 = new SetupForm222(this);
                Setup_form222.TopMost = true;          // have the setup form appear over the main form.
                Setup_form222.SampleRate.Text = SampleRate.ToString(); // pass the current Sampling Rate 
                Setup_form222.Owner = this;
                Setup_form222.Show();                  // display the Setup form
                set_frequency.Focus();              // return focus to the frequency slider
            }
            else  // form already open 
            {
                // handle setup form already being shown.  Make sure the user sees it...
                Setup_form222.Show();                  // display the Setup form
                set_frequency.Focus();              // return focus to the frequency slider
            }
        }


        public bool SetupForm222Valid()
        {
            // if the form is null or disposed, it is NOT valid
            if (Setup_form222 == null || Setup_form222.IsDisposed)
                return false;
            else
                return true;
        }
        
        private void label9_Click(object sender, EventArgs e)
        {

        }

        private void Zoom100_CheckedChanged(object sender, EventArgs e)
        {
            if (Zoom100.Checked == true)
            {
                FFTRadioPerCent = 1;
                Zoom_Track_Bar.Value = 0;
                FFTHiLimit = FFTSize;
                FFTLowLimit = 0;
                FFTPerCent = 1;
                FFTPixDispRatio = FFTSize / xWidth;
                FFTPixDispRatioInteger = (int)Math.Floor(FFTPixDispRatio);
                FFTSpan = FFTSize;
                FreqSpan = SampleRate;


            }
            byte[] textstrng = StrToByteArray("z100" + Zoom100.Checked.ToString()); //w3sz  convert to byte array


            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider
            }
        }

        private void Zoom75_CheckedChanged(object sender, EventArgs e)
        {
            if (Zoom75.Checked == true)
            {
                FFTRadioPerCent = 0.75;
                Zoom_Track_Bar.Value = 0;
                FFTHiLimit = (int)Math.Floor(FFTSize * (0.875));
                FFTLowLimit = (int)Math.Floor(FFTSize * (0.125));
                FFTPerCent = 0.75;
                FFTPixDispRatio = 0.75 * FFTSize / xWidth;
                FFTPixDispRatioInteger = (int)Math.Floor(FFTPixDispRatio);
                FFTSpan = (int)Math.Floor(FFTPerCent * FFTSize);
                FreqSpan = SampleRate * 0.75;
            }
            byte[] textstrng = StrToByteArray("z075" + Zoom75.Checked.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider

            }
        }

        private void Zoom50_CheckedChanged(object sender, EventArgs e)
        {
            if (Zoom50.Checked == true)
            {
                FFTRadioPerCent = 0.50;
                Zoom_Track_Bar.Value = 0;
                FFTHiLimit = (int)Math.Floor(FFTSize * (0.75));
                FFTLowLimit = (int)Math.Floor(FFTSize * (0.25));
                FFTPerCent = 0.50;
                FFTPixDispRatio = 0.50 * FFTSize / xWidth;
                FFTPixDispRatioInteger = (int)Math.Floor(FFTPixDispRatio);
                FFTSpan = (int)Math.Floor(FFTPerCent * FFTSize);
                FreqSpan = SampleRate * 0.50;
            }
            byte[] textstrng = StrToByteArray("z050" + Zoom50.Checked.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider
            }
        }

        private void Zoom25_CheckedChanged(object sender, EventArgs e)
        {
            if (Zoom25.Checked == true)
            {
                if (FFTSize == 4096)
                {
                    FFTRadioPerCent = 0.50;
                    FFTPerCent = 0.50;
                    Zoom_Track_Bar.Value = 0;
                    FFTHiLimit = (int)Math.Floor(FFTSize * (0.75));
                    FFTLowLimit = (int)Math.Floor(FFTSize * (0.25));
                    FFTPixDispRatio = 0.50 * FFTSize / xWidth;
                    FFTPixDispRatioInteger = (int)Math.Floor(FFTPixDispRatio);
                    FFTSpan = (int)Math.Floor(FFTPerCent * FFTSize);
                    FreqSpan = SampleRate * 0.50;
                }
                else
                {
                    FFTRadioPerCent = 0.25;
                    FFTPerCent = 0.25;
                    Zoom_Track_Bar.Value = 0;
                    FFTHiLimit = (int)Math.Floor(FFTSize * (0.625));
                    FFTLowLimit = (int)Math.Floor(FFTSize * (0.375));
                    FFTPixDispRatio = 0.25 * FFTSize / xWidth;
                    FFTPixDispRatioInteger = (int)Math.Floor(FFTPixDispRatio);
                    FFTSpan = (int)Math.Floor(FFTPerCent * FFTSize);
                    FreqSpan = SampleRate * 0.25;
                }
            }
            byte[] textstrng = StrToByteArray("z025" + Zoom25.Checked.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider
            }
        }

        private void Zoom_Track_Bar_Scroll(object sender, EventArgs e)
        {
            if (Zoom25.Checked == true)
            {
                if ((FFTSize == 524288) || (FFTSize == 262144))
                {
                    FFTPerCent = FFTRadioPerCent - (Convert.ToDouble(Zoom_Track_Bar.Value) * 0.95 / 100000.0);
                }
                else if (FFTSize == 131072)
                {
                    FFTPerCent = FFTRadioPerCent - (Convert.ToDouble(Zoom_Track_Bar.Value) * 0.90 / 100000.0);
                }
                else if (FFTSize == 65536)
                {
                    FFTPerCent = FFTRadioPerCent - (Convert.ToDouble(Zoom_Track_Bar.Value) * 0.85 / 100000.0);
                }
                else if (FFTSize == 32768)
                {
                    FFTPerCent = FFTRadioPerCent - (Convert.ToDouble(Zoom_Track_Bar.Value) * 0.75 / 100000.0);
                }
                else if (FFTSize == 16384)
                {
                    FFTPerCent = FFTRadioPerCent - (Convert.ToDouble(Zoom_Track_Bar.Value) * 0.45 / 100000.0);
                }
                else if (FFTSize == 8192)
                {
                    FFTPerCent = FFTRadioPerCent;
                }
                else if (FFTSize == 4096)
                {
                    FFTPerCent = 2 * FFTRadioPerCent;
                }
                FFTHiLimit = (int)Math.Floor(FFTSize * (0.5 + 0.5 * FFTPerCent));
                FFTLowLimit = (int)Math.Floor(FFTSize * (0.5 - 0.5 * FFTPerCent));
                FFTPixDispRatio = FFTPerCent * FFTSize / xWidth;
                FFTPixDispRatioInteger = (int)Math.Floor(FFTPixDispRatio);
                FFTSpan = (int)Math.Floor(FFTPerCent * FFTSize);
                FreqSpan = SampleRate * FFTPerCent;
            }
            else
            {
                if ((FFTSize == 4096) & (Zoom50.Checked == true))
                {
                    FFTPerCent = FFTRadioPerCent;
                }
                else
                {
                    FFTPerCent = FFTRadioPerCent - (Convert.ToDouble(Zoom_Track_Bar.Value) / 100000.0);
                }
                FFTHiLimit = (int)Math.Floor(FFTSize * (0.5 + 0.5 * FFTPerCent));
                FFTLowLimit = (int)Math.Floor(FFTSize * (0.5 - 0.5 * FFTPerCent));
                FFTPixDispRatio = FFTPerCent * FFTSize / xWidth;
                FFTPixDispRatioInteger = (int)Math.Floor(FFTPixDispRatio);
                FFTSpan = (int)Math.Floor(FFTPerCent * FFTSize);
                FreqSpan = SampleRate * FFTPerCent;
            }

            byte[] textstrng = StrToByteArray("ztra" + Zoom_Track_Bar.Value.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider
            }
        }

        //vnc to radio server
        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                string strCmdText;
                strCmdText = w3szendpoint1 + " -password=" + Properties.Settings.Default.vncpassword;
                System.Diagnostics.Process.Start(Properties.Settings.Default.vncfilelocation, strCmdText);
            }
            catch
            {
                MessageBox.Show("You need to go to Setup on the Control Bar and define filepath for VNC Executable and VNC password");
            }
        }

        private void Sidetone_CheckedChanged(object sender, EventArgs e)
        {
            if (Sidetone.Checked == true)
            {
                try
                {
                    Globals.sidetonechecked = true;
                    Form1.form1sidetonevolume = Globals.sidetonevol;
                }
                catch
                {

                }
            }
            else
            {
                try
                {
                    Globals.sidetonechecked = false;
                    Form1.form1sidetonevolume = 0.0f;
                }
                catch
                {

                }
            }
            Properties.Settings.Default.sidetonechecked = Sidetone.Checked;
            Properties.Settings.Default.Save();
        }


        private void MOX_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                if (KK_on) // only allow MOX to be set when radio is on 
                {
                    //    if (MOX.BackColor == SystemColors.Control)
                    if (MOX_set == false)
                    {
                        MOX.BackColor = Color.Green;
                        MOX_set = true;
                        if (((Mode.Text == "USB" || Mode.Text == "LSB" || Mode.Text == "FM" || Mode.Text == "AM")))
                        {
                            if ((Globals.sendMic == false) & Globals.main222)
                            {
                                Globals.sendMic = true;
                                byte[] junk;
                                try
                                {
                                    Form1.micMonOut.Volume = Form1.monVol;
                                }
                                catch { }

                                while (Form1.mic_data_queue.TryDequeue(out junk)) ;
                                try
                                {
                                    Form1.mic_in.Start();
                                }
                                catch
                                {

                                }
                            }

                            else if ((Globals.sendMicAux == false) & Globals.aux222)
                            {
                                Globals.sendMicAux = true;
                                byte[] junk;
                                try
                                {
                                    Form1.micMonOut2.Volume = Form1.monVol;
                                }
                                catch { }

                                while (Form1.mic_data_queue2.TryDequeue(out junk)) ;
                                try
                                {
                                    Form1.mic_in2.Start();
                                }
                                catch
                                {

                                }
                            }
                        }
                        else if ((Mode.Text == "CWU" || Mode.Text == "CWL"))
                        {
                            Globals.sendCW = true;
                        }
                    }
                    else if (MOX_set == true)
                    {
                        MOX.BackColor = SystemColors.Control;
                        MOX_set = false;
                        if (TUN_set)            // Force TUN off if MOX is turning off
                        {
                            TUN.BackColor = SystemColors.Control;
                            TUN_set = false;
                        }
                        if ( ((Mode.Text == "USB" || Mode.Text == "LSB" || Mode.Text == "FM" || Mode.Text == "AM")))
                        {
                            if ((Globals.sendMic == true) & Globals.main222)
                            {
                                Globals.sendMic = false;
                                try
                                {
                                    Form1.micMonOut.Volume = 0.0f;
                                }
                                catch { }

                                try
                                {
                                    Form1.mic_in.Stop();
                                }
                                catch
                                {

                                }
                            }
                            else if ((Globals.sendMicAux == true) & Globals.aux222)
                            {
                                Globals.sendMicAux = false;
                                try
                                {
                                    Form1.micMonOut2.Volume = 0.0f;
                                }
                                catch { }

                                try
                                {
                                    Form1.mic_in2.Stop();
                                }
                                catch
                                {

                                }
                            }
                        }
                        else if ((Mode.Text == "CWU" || Mode.Text == "CWL"))
                        {
                            Globals.sendCW = false;
                        }

                    }


                    byte[] textstrng = StrToByteArray("moxo" + (!MOX_set).ToString()); //w3sz  convert to byte array

                    if (Properties.Settings.Default.Checked222)
                    {
                //        sendCommandAsync(textstrng, w3szendpoint1, port1);
                        sendCommand(textstrng, w3szendpoint1, port1);

                        DriveLevel_Scroll(this, EventArgs.Empty); // force drive level update
                        setVolumeSquelched();  // check if we need to mute the receiver audio
                        set_frequency.Focus(); // return focus to the frequency slider
                    }
                }
            }

            else if (e.Button == MouseButtons.Right)
            {
                MOX.BackColor = SystemColors.Control;
                Globals.sendCW = false;
                Globals.sendMic = false;
                Globals.sendMicAux = false;
                MOX_set = false;
            }
        }

        public void TUN_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                if (KK_on) // only allow TUN to be set when radio is on 
                {
                    //             if (TUN.BackColor == SystemColors.Control)
                    if (TUN_set == false)
                    {
                        TUN.BackColor = Color.Green;
                        TUN_set = true;
                        // Need MOX on when Tune is set 
                        MOX_set = true;
                        MOX.BackColor = Color.Green;
                    }
                    else
                    {
                        TUN.BackColor = SystemColors.Control;
                        TUN_set = false;
                        MOX_set = false;                   // force MOX off 
                        MOX.BackColor = SystemColors.Control;

                    }


                    byte[] textstrng = StrToByteArray("tune" + TUN_set.ToString()); //w3sz  convert to byte array

                    if (Properties.Settings.Default.Checked222)
                    {
             //       sendCommandAsync(textstrng, w3szendpoint1, port1);
                    sendCommand(textstrng, w3szendpoint1, port1);

                    DriveLevel_Scroll(this, EventArgs.Empty); // force drive level update
                    set_frequency.Focus(); // return focus to the frequency slider
                }
            }

            if (e.Button == MouseButtons.Right)
            {
                TUN.BackColor = SystemColors.Control;
                MOX.BackColor = SystemColors.Control;
                MOX_set = false;
                TUN_set = false;
            }
        }
    }

        public async Task sendCommandAsync(byte[] command, string endpoint, int port)
        {
            Task task = Task.Run(() => sendCommand(command,endpoint,port));
            await task;
        }

        public void sendCommand(byte[] command, string endpoint, int port)
        {
            int commandLength = command.Length;
            //this is UI command sender; sends commands back to radio //w3sz
            UdpClient udpServer4 = new UdpClient(); //w3sz
            IPEndPoint localpt4 = new IPEndPoint(IPAddress.Parse(endpoint), port);  //w3sz  command

            udpServer4.ExclusiveAddressUse = false;  //w3sz
            udpServer4.Client.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.ReuseAddress, true);  //w3sz
            try
            {
                udpServer4.Client.Connect(localpt4);  //w3sz changed was client.bind Jan 2024
            }
            catch
            {
            }
            udpServer4.Send(command, commandLength, localpt4); // reply back  //w3sz 
            udpServer4.Close(); //w3sz   
        }



        public async Task sendsetupCommandAsync(
                   byte[] modetextstrng, byte[] leftvoltextstrng, byte[] rightvoltextstrng, byte[] AGCMaxGaintextstrng,
                   byte[] Drivetextstrng, byte[] frequencytextstrng, byte[] squelchtextstrng, byte[] squelchOntextstrng,
                   byte[] filtersquelchOntextstrng, byte[] stepsizetextstrng, byte[] AGCSpeedtextstrng,
                   byte[] ANFCheckedtextstrng, byte[] NRCheckedtextstrng, byte[] NB1Checkedtextstrng,
                   byte[] NB2Checkedtextstrng, byte[] PreampCheckedtextstrng, byte[] chkClippertextstrng, byte[] chkNoiseGatetextstrng,
                   byte[] ProcessorGaintextstrng, byte[] MicGaintextstrng, byte[] NGLeveltextstrng, byte[] labelFilterWidthtextstrng,
                   byte[] SampleRatetextstrng, byte[] Zoom100textstrng, byte[] Zoom75textstrng, byte[] Zoom50textstrng,
                   byte[] Zoom25textstrng, byte[] ZoomTrackBartextstrng, byte[] FFTSizetextstrng, byte[] gaintextstrng, byte[] CWPitchtextstrng, 
                   byte[] frequencyBstrng, byte[] splitstrng,
                   byte[] DataCodectextstrng, byte[] DataBRtextstrng, byte[] VoiceCodectextstrng, byte[] VoiceBRtextstrng,
                   byte[] DataBWtextstrng, byte[] VoiceBWtextstrng,
                   byte[] opusTxComptextstrng, byte[] opusComptextstrng, byte[] mainMictextstrng, byte[] auxMictextstrng,
                   string endpoint,int port)
        {
            Task task = Task.Run(() => sendsetupCommand(
                   modetextstrng, leftvoltextstrng, rightvoltextstrng, AGCMaxGaintextstrng,
                   Drivetextstrng, frequencytextstrng, squelchtextstrng, squelchOntextstrng,
                   filtersquelchOntextstrng, stepsizetextstrng, AGCSpeedtextstrng,
                   ANFCheckedtextstrng, NRCheckedtextstrng, NB1Checkedtextstrng,
                   NB2Checkedtextstrng, PreampCheckedtextstrng, chkClippertextstrng, chkNoiseGatetextstrng,
                   ProcessorGaintextstrng, MicGaintextstrng, NGLeveltextstrng, labelFilterWidthtextstrng,
                   SampleRatetextstrng, Zoom100textstrng, Zoom75textstrng, Zoom50textstrng,
                   Zoom25textstrng, ZoomTrackBartextstrng, FFTSizetextstrng, gaintextstrng, CWPitchtextstrng, frequencyBstrng,
                   splitstrng,  DataCodectextstrng, DataBRtextstrng, VoiceCodectextstrng, VoiceBRtextstrng,
                   DataBWtextstrng, VoiceBWtextstrng, opusTxComptextstrng, opusComptextstrng, mainMictextstrng, auxMictextstrng,
                   endpoint, port));
            await task;
        }

        public void sendsetupCommand(
                   byte[] modetextstrng, byte[] leftvoltextstrng, byte[] rightvoltextstrng, byte[] AGCMaxGaintextstrng,
                   byte[] Drivetextstrng, byte[] frequencytextstrng, byte[] squelchtextstrng, byte[] squelchOntextstrng,
                   byte[] filtersquelchOntextstrng, byte[] stepsizetextstrng, byte[] AGCSpeedtextstrng,
                   byte[] ANFCheckedtextstrng, byte[] NRCheckedtextstrng, byte[] NB1Checkedtextstrng,
                   byte[] NB2Checkedtextstrng, byte[] PreampCheckedtextstrng, byte[] chkClippertextstrng, byte[] chkNoiseGatetextstrng,
                   byte[] ProcessorGaintextstrng, byte[] MicGaintextstrng, byte[] NGLeveltextstrng, byte[] labelFilterWidthtextstrng,
                   byte[] SampleRatetextstrng, byte[] Zoom100textstrng, byte[] Zoom75textstrng, byte[] Zoom50textstrng,
                   byte[] Zoom25textstrng, byte[] ZoomTrackBartextstrng, byte[] FFTSizetextstrng, byte[] gaintextstrng, byte[] CWPitchtextstrng,
                   byte[] frequencyBstrng, byte[] splitstrng,  byte[] DataCodectextstrng, 
                   byte[] DataBRtextstrng, byte[] VoiceCodectextstrng, byte[] VoiceBRtextstrng,
                   byte[] DataBWtextstrng, byte[] VoiceBWtextstrng, byte[] opusTxComptextstrng, byte[] opusComptextstrng, byte[] mainMictextstrng, byte[] auxMictextstrng,
                   string endpoint, int port)
        {

            int modestrngsize = modetextstrng.Length;  //w3sz  get byte array size              
            int leftvolstrngsize = leftvoltextstrng.Length;  //w3sz  get byte array size
            int rightvolstrngsize = rightvoltextstrng.Length;  //w3sz  get byte array size
            int AGCMaxGainstrngsize = AGCMaxGaintextstrng.Length;  //w3sz  get byte array size
            int Drivestrngsize = Drivetextstrng.Length;  //w3sz  get byte array size
            int frequencystrngsize = frequencytextstrng.Length;  //w3sz  get byte array size
            int squelchstrngsize = squelchtextstrng.Length;  //w3sz  get byte array size
            int squelchOnstrngsize = squelchOntextstrng.Length;  //w3sz  get byte array size
            int filtersquelchOnstrngsize = filtersquelchOntextstrng.Length;  //w3sz  get byte array size
            int stepsizestrngsize = stepsizetextstrng.Length;  //w3sz  get byte array size
            int AGCSpeedstrngsize = AGCSpeedtextstrng.Length;  //w3sz  get byte array size
            int ANFCheckedstrngsize = ANFCheckedtextstrng.Length;  //w3sz  get byte array size
            int NRCheckedstrngsize = NRCheckedtextstrng.Length;  //w3sz  get byte array size
            int NB1Checkedstrngsize = NB1Checkedtextstrng.Length;  //w3sz  get byte array size
            int NB2Checkedstrngsize = NB2Checkedtextstrng.Length;  //w3sz  get byte array size
            int PreampCheckedstrngsize = PreampCheckedtextstrng.Length;  //w3sz  get byte array size
            int chkClipperstrngsize = chkClippertextstrng.Length;  //w3sz  get byte array size
            int chkNoiseGatestrngsize = chkNoiseGatetextstrng.Length;  //w3sz  get byte array size
            int ProcessorGainstrngsize = ProcessorGaintextstrng.Length;  //w3sz  get byte array size
            int MicGainstrngsize = MicGaintextstrng.Length;  //w3sz  get byte array size
            int NGLevelstrngsize = NGLeveltextstrng.Length;  //w3sz  get byte array size
            int labelFilterWidthstrngsize = labelFilterWidthtextstrng.Length;  //w3sz  get byte array size
            int SampleRatetextstrngsize = SampleRatetextstrng.Length;
            int Zoom100strngsize = Zoom100textstrng.Length;  //w3sz  get byte array size
            int Zoom75strngsize = Zoom75textstrng.Length;  //w3sz  get byte array size
            int Zoom50strngsize = Zoom50textstrng.Length;  //w3sz  get byte array size
            int Zoom25strngsize = Zoom25textstrng.Length;  //w3sz  get byte array size
            int ZoomTrackBarstrngsize = ZoomTrackBartextstrng.Length;  //w3sz  get byte array size
            int FFTSizetextstrngsize = FFTSizetextstrng.Length;
            int gainstrngsize = gaintextstrng.Length;  //w3sz  get byte array size
            int CWPitchstrngsize = CWPitchtextstrng.Length;  //w3sz  get byte array size
            int frequencyBstrngsize = frequencyBstrng.Length;  //w3sz get byte array size
            int splitstrngsize = splitstrng.Length;  //w3sz get byte array size
            int DataCodectextstrngsize = DataCodectextstrng.Length;
            int DataBRtextstrngsize = DataBRtextstrng.Length;
            int VoiceCodectextstrngsize = VoiceCodectextstrng.Length;
            int VoiceBRtextstrngsize = VoiceBRtextstrng.Length;
            int DataBWtextstrngsize = DataBWtextstrng.Length;
            int VoiceBWtextstrngsize = VoiceBWtextstrng.Length;
            int opusTxComptextstrngsize = opusTxComptextstrng.Length;
            int opusComptextstrngsize = opusComptextstrng.Length;
            int mainMictextstrngsize = mainMictextstrng.Length;
            int auxMictextstrngsize = auxMictextstrng.Length;
            //this is UI command sender; sends commands back to radio //w3sz
            UdpClient udpServer4 = new UdpClient(); //w3sz
            IPEndPoint localpt4 = new IPEndPoint(IPAddress.Parse(endpoint), port);  //w3sz  command

            udpServer4.ExclusiveAddressUse = false;  //w3sz
            udpServer4.Client.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.ReuseAddress, true);  //w3sz
            try
            {
                udpServer4.Client.Connect(localpt4);  //w3sz changed was client.bind Jan 2024
            }
            catch
            {
            }
            udpServer4.Send(modetextstrng, modestrngsize, localpt4); // reply back  //w3sz  
            udpServer4.Send(leftvoltextstrng, leftvolstrngsize, localpt4); // reply back  //w3sz  
            udpServer4.Send(rightvoltextstrng, rightvolstrngsize, localpt4); // reply back  //w3sz  
            udpServer4.Send(AGCMaxGaintextstrng, AGCMaxGainstrngsize, localpt4); // reply back  //w3sz  
            udpServer4.Send(Drivetextstrng, Drivestrngsize, localpt4); // reply back  //w3sz  
            udpServer4.Send(frequencytextstrng, frequencystrngsize, localpt4); // reply back  //w3sz  
            udpServer4.Send(squelchtextstrng, squelchstrngsize, localpt4); // reply back  //w3sz  
            udpServer4.Send(squelchOntextstrng, squelchOnstrngsize, localpt4); // reply back  //w3sz  
            udpServer4.Send(filtersquelchOntextstrng, filtersquelchOnstrngsize, localpt4); // reply back  //w3sz  
            udpServer4.Send(stepsizetextstrng, stepsizestrngsize, localpt4); // reply back  //w3sz  
            udpServer4.Send(AGCSpeedtextstrng, AGCSpeedstrngsize, localpt4); // reply back  //w3sz  
            udpServer4.Send(ANFCheckedtextstrng, ANFCheckedstrngsize, localpt4); // reply back  //w3sz  
            udpServer4.Send(NRCheckedtextstrng, NRCheckedstrngsize, localpt4); // reply back  //w3sz  
            udpServer4.Send(NB1Checkedtextstrng, NB1Checkedstrngsize, localpt4); // reply back  //w3sz  
            udpServer4.Send(NB2Checkedtextstrng, NB2Checkedstrngsize, localpt4); // reply back  //w3sz  
            udpServer4.Send(PreampCheckedtextstrng, PreampCheckedstrngsize, localpt4); // reply back  //w3sz  
            udpServer4.Send(chkClippertextstrng, chkClipperstrngsize, localpt4); // reply back  //w3sz  
            udpServer4.Send(chkNoiseGatetextstrng, chkNoiseGatestrngsize, localpt4); // reply back  //w3sz  
            udpServer4.Send(ProcessorGaintextstrng, ProcessorGainstrngsize, localpt4); // reply back  //w3sz  
            udpServer4.Send(MicGaintextstrng, MicGainstrngsize, localpt4); // reply back  //w3sz  
            udpServer4.Send(NGLeveltextstrng, NGLevelstrngsize, localpt4); // reply back  //w3sz  
            udpServer4.Send(labelFilterWidthtextstrng, labelFilterWidthstrngsize, localpt4); // reply back 
            udpServer4.Send(SampleRatetextstrng, SampleRatetextstrngsize, localpt4); // reply back  //w3sz   
            udpServer4.Send(Zoom100textstrng, Zoom100strngsize, localpt4); // reply back  //w3sz   
            udpServer4.Send(Zoom75textstrng, Zoom75strngsize, localpt4); // reply back  //w3sz 
            udpServer4.Send(Zoom50textstrng, Zoom50strngsize, localpt4); // reply back  //w3sz  
            udpServer4.Send(Zoom25textstrng, Zoom25strngsize, localpt4); // reply back  //w3sz  
            udpServer4.Send(ZoomTrackBartextstrng, ZoomTrackBarstrngsize, localpt4); // reply back  //w3sz  
            udpServer4.Send(FFTSizetextstrng, FFTSizetextstrngsize, localpt4); // reply back  //w3sz 
            udpServer4.Send(gaintextstrng, gainstrngsize, localpt4); // reply back  //w3sz  
            udpServer4.Send(CWPitchtextstrng, CWPitchstrngsize, localpt4);  //w3sz
            udpServer4.Send(frequencyBstrng, frequencyBstrngsize, localpt4); // reply back  //w3sz  
            udpServer4.Send(splitstrng, splitstrngsize, localpt4);  //w3sz
            udpServer4.Send(DataCodectextstrng, DataCodectextstrngsize, localpt4);  //w3sz
            udpServer4.Send(DataBRtextstrng, DataBRtextstrngsize, localpt4);  //w3sz
            udpServer4.Send(VoiceCodectextstrng, VoiceCodectextstrngsize, localpt4);  //w3sz
            udpServer4.Send(VoiceBRtextstrng, VoiceBRtextstrngsize, localpt4);  //w3sz
            udpServer4.Send(DataBWtextstrng, DataBWtextstrngsize, localpt4);  //w3sz
            udpServer4.Send(VoiceBWtextstrng, VoiceBWtextstrngsize, localpt4);  //w3sz
            udpServer4.Send(opusTxComptextstrng, opusTxComptextstrngsize, localpt4);
            udpServer4.Send(opusComptextstrng, opusComptextstrngsize, localpt4);
            udpServer4.Send(mainMictextstrng, mainMictextstrngsize, localpt4);
            udpServer4.Send(auxMictextstrng, auxMictextstrngsize, localpt4);

            udpServer4.Close(); //w3sz 
        }

        private void splitBox_CheckedChanged(object sender, EventArgs e)
        {
            byte[] textstrng = StrToByteArray("splt" + splitBox.Checked.ToString()); //w3sz  convert to byte array

            if (Properties.Settings.Default.Checked222)
            {
                sendCommandAsync(textstrng, w3szendpoint1, port1);
                set_frequency.Focus(); // return focus to the frequency slider
            }
           if(splitBox.Checked)
            {
                Properties.Settings.Default.split222 = true;
            }
            else
            {
                Properties.Settings.Default.split222 = false;
            }

        }

        private void AtoBBut_Click(object sender, EventArgs e)
        {
            Properties.Settings.Default.split_tx_freq222 = set_frequency.Value;
            Properties.Settings.Default.Save();
            DisplayFrequencyB(Properties.Settings.Default.split_tx_freq222);

            byte[] textstrng = StrToByteArray("AtoB"); //w3sz  convert to byte array
            sendCommandAsync(textstrng, w3szendpoint1, port1);
            set_frequency.Focus(); // return focus to the frequency slider
        }

        private void BtoABut_Click(object sender, EventArgs e)
        {
            set_frequency.Value = Convert.ToInt32(Properties.Settings.Default.split_tx_freq222);
            DisplayFrequency(set_frequency.Value);

            byte[] textstrng = StrToByteArray("BtoA"); //w3sz  convert to byte array
            sendCommandAsync(textstrng, w3szendpoint1, port1);
            set_frequency.Focus(); // return focus to the frequency slider
        }
    } 

}

